#!/usr/bin/perl -w
use strict;


`hostname`=~/(\S+)/;
my $node=$1;
my $datetime=`date`;
my $path=`pwd`;
my $start=time();
print "Hostname: $node\n";
print "Started : $datetime\n";
print "Path    : $path\n";
######################################################
#########Variables to be set dynamically##############
my $s              ="51";       # BSP000005
my $datadir        ="/nfs/amino-home/zhanglabs/IonCom/output/51"; # /home/zhanglabs/BioLiP/output
my $model          ="protein.pdb";   # protein.pdb



my $dname   = "COACH";
my $library = "/nfs/amino-library";
my $bindir  = "/nfs/amino-home/zhanglabs/$dname/bin";
my $wwwlink = "http://zhanglab.ccmb.med.umich.edu/$dname/output/$s";
my $wwwloc  = "/www/html/$dname/output/$s";
my $message = '';


################################################################################
my $modelname=$model;
$modelname =~ s/\.pdb//;

if(!-s "$datadir/seq.txt")
{
    die "seq.txt is missed!\n";
}

my $pname=`cat $datadir/pname.txt`;
chomp($pname);

my $seq     = `cat $datadir/seq.txt`;
my @lines   = split "\n",$seq;
my $sequence='';
foreach my $line(@lines)
{
    if($line!~/\>/)
    {
	$line=~tr/a-z/A-Z/;
	$line =~ s/[\s+|\n+|\d+|\*|\-]//mg;
	$sequence=$sequence.$line;
    }
}
my $Lch = length $sequence;

###############################################################################


my $BSDIR       = "$datadir/$modelname/cofactor";
my $OUTPUT_BS   = "Bsites.dat";

#Ligand binding site predictions

my ($bsdiv, $conf, $results)  = &makeCOFACTORdiv($datadir, $model, $BSDIR, $OUTPUT_BS, $sequence, $bindir, $wwwlink);


$BSDIR     = "$datadir/$modelname/tmsite";
$OUTPUT_BS = "Bsites_single.dat";
my ($bsdiv1, $conf1, $results1)  = &makeTMSITEdiv($datadir, $model, $BSDIR, $OUTPUT_BS, $sequence, $bindir, $wwwlink);



$BSDIR     = "$datadir/$modelname/findsite";
$OUTPUT_BS = "$modelname.pockets.dat";
my ($bsdiv2, $conf2, $results2)  = &makeFINDSITEdiv($datadir, $model, $BSDIR, $OUTPUT_BS, $sequence, $bindir, $wwwlink);


$BSDIR     = "$datadir/ssite";
$OUTPUT_BS = "Bsites_dis.dat";
my ($bsdiv3, $conf3, $results3) = &makeSSITEdiv($datadir, $model, $BSDIR, $OUTPUT_BS, $sequence, $bindir, $wwwlink);


$BSDIR     = "$datadir/$modelname/concavity";
$OUTPUT_BS = "Bsites_$modelname.dat";
my ($bsdiv4, $results4)     = &makeConCavitydiv($datadir, $model, $BSDIR, $OUTPUT_BS, $sequence, $bindir, $wwwlink);


$BSDIR     = "$datadir/$modelname/coach";
$OUTPUT_BS = "Bsites.inf";
my $bsdiv5  = &makeCLRdiv($datadir, $model, $BSDIR, $OUTPUT_BS, $sequence, $bindir, $wwwlink);




`rm -f $datadir/ssite/sresult.dat`;
#`rm -f $datadir/ssite/Bsites_prob*`;
#`rm -f $datadir/ssite/Bsites_dis*`;
`rm -f $datadir/ssite/SS*`;
`scp -r $datadir/ssite zhanglabs\@zhanglab.ccmb.med.umich.edu:$wwwloc`;

`rm -f $datadir/protein/tmsite/tms_*`;
`rm -f $datadir/protein/cofactor/lig_*`;
`rm -f $datadir/protein/findsite/lig_*`;
`scp -r $datadir/protein zhanglabs\@zhanglab.ccmb.med.umich.edu:$wwwloc`;
`scp -r $datadir/protein.pdb zhanglabs\@zhanglab.ccmb.med.umich.edu:$wwwloc`;

my $other= $results1 . $results . $results2 . $results3 . $results4;

#$BSDIR     = "$datadir/$modelname";
#$OUTPUT_BS = "coach_cluster.dat";
#my $bsdiv5     = &makeCOACHdiv($datadir, $model, $BSDIR, $OUTPUT_BS, $sequence, $bindir, $wwwlink, $cscore, $other);


#<!---- block 1 --->
#$html    .= $bsdiv5 . $bsdiv3 . "&nbsp;" . $bsdiv4;



#####Make HTML header
my $html  = '';
$html    .= "<html>\n<head>\n  <title>COACH results for job $s ($pname)</title>\n</head>\n\n";
$html    .= "<html><link rel=\"stylesheet\" type=\"text/css\" href=\"../../page.css\" />\n";

$html    .= "<script type=\"text/javascript\" src=\"../../jmol/Jmol.js\"></script>\n";
$html    .= "<body bgcolor=\"#FFFFFF\">\n";

$html    .= "<br><a href=\"../../\">[Back to COACH server</a>]<br>";

$html    .= "<font face=\"Times New Roman\">\n";
$html    .= "<br/>\n";
$html    .= "<table style=\"table-layout:fixed;\" width=\"100%\" cellpadding=\"2\" cellspacing=\"0\">\n";
$html    .= " <tr><td>   <h1 align=\"center\"> COACH results for job $s ($pname)</h1></td></tr>";

$html    .= "<tr><td>\n";
if(-s "$datadir/protein.fasta")
{
    my $tmscore="";
    my @rst = `cat $datadir/cscore`;
    foreach my $line(@rst)
    {
	if($line =~ /model1:\s+\S+\s+(\S+)/)
	{
	    $tmscore=$1;
	    last;
	}
    }
    if($tmscore ne "")
    {
	$html    .= "<a href=$wwwlink/protein.pdb>Download the predicted 3D model by I-TASSER</a> (the estimated TM-score is: $tmscore)<br><br>";
    }
    else
    {
	my $zscore=$rst[0];
	chomp($zscore);
	$html    .= "<a href=$wwwlink/protein.pdb>Download the predicted 3D model</a> ($zscore)<br><br>";
    }
}
else
{
    $html    .= "<a href=$wwwlink/protein.pdb>Download the submitted query structure file</a><br><br>";
}
$html    .= "</td></tr>\n";



$html     .= $bsdiv5  . "&nbsp;" . $bsdiv1  . "&nbsp;" . $bsdiv3  . "&nbsp;" . $bsdiv  . "&nbsp;" . $bsdiv2  . "&nbsp;" . $bsdiv4;








################################################################################
$html    .="<tr><td><br/><br/></td></tr>\n";
$html    .="<tr><td><hr><br/><div style=\"position:relative;left:30px;\"><table style=\"font-family:Arial;font-size:14px;\"><tr><td>&nbsp;</td><td>Please cite the following articles when you use the COACH server:</td><tr>\n";

$html    .="<tr><td valign=\"top\">1.</td><td> Jianyi Yang, Ambrish Roy and Yang Zhang, <i>Protein-ligand binding site recognition using complementary binding-specific substructure comparison and sequence profile alignment</i>, Bioinformatics, 29: 2588-2595 (2013) (<a href=http://zhanglab.ccmb.med.umich.edu/COACH/COACH.pdf>download the PDF file</a>)</td></tr>\n"; 

$html    .="<tr><td valign=\"top\">2.</td><td> Jianyi Yang, Ambrish Roy and Yang Zhang,<i> BioLiP: a semi-manually curated database for biologically relevant ligand-protein interactions.</i>, Nucleic Acids Research, 41: D1096-D1103 (2013) (<a href=http://zhanglab.ccmb.med.umich.edu/papers/2013_1.pdf>download the PDF file</a>).</td></tr>\n"; 


$html    .="</table></div></td></tr>\n";
$html    .="</table></body>\n</html>";


$html .= "<script type=\"text/JavaScript\">

function toggle2(showHideDiv, switchTextDiv) {
	var ele = document.getElementById(showHideDiv);
	var text = document.getElementById(switchTextDiv);
	if(ele.style.display == \"block\") {
    		ele.style.display = \"none\";
		text.innerHTML = \"Show\";
  	}
	else {
		ele.style.display = \"block\";
		text.innerHTML = \"Hide\";
	}
}

</script>";

open(OUT,">$datadir/index.html");
print OUT "$html\n";
close(OUT);
$message="Output file index.html was generated successfully";

 posexit:;
open(ST,">>$datadir/status_report");
printf ST "$message\n";
close(ST);


my $time=`date`;
open(FIN,">$datadir/finished.txt");
print FIN "Job finished at $time";
close(FIN);


 `scp $datadir/index.html zhanglabs\@zhanglab.ccmb.med.umich.edu:$wwwloc`;
 `scp $datadir/finished.txt zhanglabs\@zhanglab.ccmb.med.umich.edu:$wwwloc`;

`sync`;
`sync`;
sleep(2);
exit(); 


sub makeCOFACTORdiv
{
    my($dir1, $model, $dir2, $filename, $sequence, $bin, $www)=@_;      
    my $MAXP= 5;
    my $div ='';    
    my %ts=(
        'ALA'=>'A', 'ARG'=>'R', 'ASN'=>'N', 'ASP'=>'D', 'CYS'=>'C', 'GLN'=>'Q', 'GLU'=>'E', 'GLY'=>'G',
        'HIS'=>'H', 'ILE'=>'I', 'LEU'=>'L', 'LYS'=>'K', 'MET'=>'M', 'PHE'=>'F', 'PRO'=>'P', 'SER'=>'S',
        'THR'=>'T', 'TRP'=>'W', 'TYR'=>'Y', 'VAL'=>'V', 'ASX'=>'N', 'GLX'=>'Q', 'UNK'=>'G',
        'A'=>'ALA', 'R'=>'ARG', 'N'=>'ASN', 'D'=>'ASP', 'C'=>'CYS', 'Q'=>'GLN', 'E'=>'GLU', 'G'=>'GLY',
        'H'=>'HIS', 'I'=>'ILE', 'L'=>'LEU', 'K'=>'LYS', 'M'=>'MET', 'F'=>'PHE', 'P'=>'PRO', 'S'=>'SER',
        'T'=>'THR', 'W'=>'TRP', 'Y'=>'TYR', 'V'=>'VAL', 'B'=>'ASX', 'Z'=>'GLX', 'X'=>'UNK');
 
   
    $div    ='';
    $div   .= "  <tr><td>\n";
    $div   .= "   <br/><div style=\"background:#FF9900; \">\n";
    $div   .= "      <table><tr><td  valign=\"middle;\">\n";
    $div   .= "        <font color=\"#FFFFFF\" size=\"4\" face=\"Arial\">&nbsp;&nbsp;COFACOTR Results</font>\n";
    $div   .= "      </td></tr></table>\n";
    $div   .= "   </div>\n";
    #$div   .= "   <br/>\n";
    $div   .= "   <div style=\"position:relative; background:#F2F2F2;width:100%\">\n";
    $div   .= "       <table border=\"0\" style=\"background:#F2F2F2;align=\"left\">\n";




    $div ='';
    $div    .= "

<tr> <td>
<div id=\"headerDiv\">
     <div id=\"titleText\">COFACTOR Results</div>
      <a id=\"CFHeader\" href=\"javascript:toggle2('CFContent','CFHeader');\" >Hide</a>
</div>
<div style=\"clear:both;\"></div>
<div id=\"contentDiv\">
     <div id=\"CFContent\" style=\"display: block;\">";
   

    $div   .= "   <div style=\"position:relative; background:#F2F2F2;width:100%\">\n";
    $div   .= "       <table border=\"0\" style=\"background:#F2F2F2;align=\"left\" cellpadding=\"10\">\n";









    my $results="";


    my %xs=(); my %ys=();  my %zs=();
    open(PDB,"$dir1/$model");
    while(my $line2=<PDB>)
    {
	my $record     = substr($line2,0,6);
	if($record eq "ATOM  ")
	{
	    my $atom_name = substr($line2,12,4);
	    my $res_no    = substr($line2,22,4);$res_no    =~s/\s+//;
	    if($atom_name eq ' CA ' || $atom_name eq '  CA' || $atom_name eq 'CA  ')
	    {
		$xs{$res_no} =substr($line2,30,8);
		$ys{$res_no} =substr($line2,38,8);
		$zs{$res_no} =substr($line2,46,8);
	    }
	}
    }
    close(PDB);

    my $conf=0;

    my $ligtype="";
    my $firstbs='';

    if(!-s "$dir2/$filename")
    {
	$div     .= "    <td><b>No binding site was predicted by COFACTOR.</b></td></tr>\n";
	$results .= "    <tr  bgcolor=\"#DEDEDE\"><td><b>COFACTOR</b></td><td></td><td></td><td>No binding site was predicted by COFACTOR.</td></tr>\n";
	
	goto nobs;
    }
    open(RESULT,"<$dir2/$filename");
    my $line3=<RESULT>;

    close(RESULT);
    if($line3=~/(\d+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\:(\S+)/)
    {
	$ligtype=$8;
	$firstbs=$17;
    }    
    elsif($line3=~/No Binding/)
    {
        $div    .= "    <td><b>No binding site was predicted by COFACTOR.</b></td></tr>\n";
        goto nobs;
    }
    my @firstres=split(/\,/,$firstbs);

	$div    .="       <tr><td align =\"center\"><script type=\"text/javascript\">jmolInitialize(\"../../jmol/\")\;jmolSetAppletColor(\"#000000\")\;jmolApplet(500, \"load protein/cofactor/complex1.pdb; set frank off; select all; spacefill off; wireframe off; cartoons; select $firstbs; wireframe 75; spacefill 100; color blue;";
       
    my $xcm1=0;  my $ycm1=0;  my $zcm1=0;
    foreach my $r(@firstres)
    {
	$div .= "select $r and \*.ca; label %m%r; color label magenta;";
    }	
    if($ligtype =~ /NUC/)
    {
	$div .= " select hetero; color greenyellow; spacefill;  spacefill off;  wireframe off; spacefill off; set ambient 40;  ";
    }
    else
    {
	$div .= " select hetero; spacefill 95\%; set radius 0.90; color greenyellow; set ambient 40;";
    }

    $div     .="     set spin x 10; set spin y 10; spin off;\");</script><br/><SCRIPT>jmolCheckbox(\"set spin x 10; set spin y 10; spin on\", \"spin off\", \"Spin On/Off\", false)</SCRIPT>
</td>\n";
    $div    .="       <td valign=\"top\">";
    $div    .="       <table  border=\"0\" style=\"font-family:Arial;font-size:13px;\"><tr bgcolor=\"#DEDEDE\"><th>Click to view</th><th>Rank</th><th>C-score<sup>a</sup></th><th>PDB<br/>Hit</th><th>TM-score</th><th>RMSD<sup>b</sup></th><th>IDEN<sup>c</sup></th><th>Cov<sup>d</sup></th><th>BS-score<sup>e</sup></th><th>Lig. Name</th><th>Download<br/>Complex</th><th align=\"left\"> Predicted binding site residues</th></tr>\n";
   
    my $i=0;
    my %T_tmscore=(); my %T_rmsd=();  my %T_iden=();    my %T_cov=();
    my %hits=();      my %ligands=();my %BS_score=();   my %LTM=();
    my %BS_ID=();     my %BS_cov=(); my %BS_err=();     my %BS_ID1=();
    my %BS_ID2=();    my %PBS=();    my %Rank_scores=();my %Cscore=(); 
    
    open(RESULT,"<$dir2/$filename");
    while(my $line2=<RESULT>)
    {

        if($line2=~/(\d+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\:(\S+)/)
        {
	   
            $i             =$1;
	    $Cscore{$i}    =sprintf("%4.2f",$2);
            $hits{$i}      =$3;
            $T_tmscore{$i} =sprintf("%4.3f",$4);
            $T_rmsd{$i}    =sprintf("%5.2f",$5);
            $T_iden{$i}    =sprintf("%4.3f",$6);
            $T_cov{$i}     =sprintf("%4.3f",$7);
	    my $ligname    =$8;
	    $ligname       ='PEPTIDE'  if ($ligname eq 'III');
	    $ligname       ='Nuc.Acid' if ($ligname eq 'NUC');
            $ligname       ='k-mer' if ($ligname eq 'UUU');
            $ligands{$i}   =$9;
            $BS_score{$i}  =sprintf("%4.2f",$10); $BS_score{$i}  = 2.0 if($BS_score{$i} > 2.0);
            $LTM{$i}       =$11;
            $BS_ID{$i}     =$12;
            $BS_cov{$i}    =$13;
            $BS_err{$i}    =$14;
            $BS_ID1{$i}    =$15;
            $BS_ID2{$i}    =$16;
            $PBS{$i}       =$17;
	    my $pbsr= $PBS{$i};

	    #$pbsr =~ s/,/, /g;


	    if($i==1)
	    {
		$conf=$Cscore{$i};
	    }
			   
            if($i > $MAXP)
            {
                goto loopout1;
            }

	    if($i==1)
	    {
		$results .= "<tr bgcolor=\"#DEDEDE\"><td><b>COFACTOR</b></td><td>$i</td><td>$Cscore{$i}</td><td>$pbsr</td></tr>";
	    }
	    else
	    {
		$results .= "<tr><td></td><td>$i</td><td>$Cscore{$i}</td><td>$pbsr</td></tr>";
	    }

	    my $bgcolor="";
	    if($i%2==0)
	    {
		#$bgcolor="bgcolor=\"#F0FFF0\"";
		$bgcolor="bgcolor=\"#DEDEDE\"";
		#$bgcolor="bgcolor=white";
	    }

	    my $checked="false";
	    if($i == 1)
	    {
		#$checked="true";
	    }

	    my @res=split(/\,/,$PBS{$i});
	    my $comx=0; my $comy=0;  my $comz=0;	  
	   # `/bin/cp $dir2/complex$i.pdb $dir1/$modelname\_bs$i.pdb`;
	    #`scp $dir2/complex$i.pdb zhanglabs\@zhanglab.ccmb.med.umich.edu:$wwwloc`;
            my $pdbcode=substr($hits{$i},0,4);
	    $div .= "       <tr $bgcolor>\n";
	    
	    $div .= "       <td align=\"center\"><script language=\"JavaScript\" type=\"text/javascript\">jmolRadio(\"load protein/cofactor/complex$i.pdb; set frank off; select all;  spacefill off; wireframe off; cartoons; select $pbsr; wireframe 75; spacefill 100; color blue;";	
	    
	    foreach my $r(@res)
	    {
		$div .= "select $r and \*.ca; label %m%r; color label magenta;";
	    }

	    if($ligname eq 'Nuc.Acid')
	    {
		$div .= " select hetero; color greenyellow; spacefill;  spacefill off; wireframe off; spacefill off; set ambient 40;  ";
	    }
	    else
	    {
		$div .= " select hetero; spacefill 95\%; set radius 0.90; color greenyellow; set ambient 40; ";
	    }	    

            $div .= "    set spin x 5; set spin y 5; spin off;\", \"\", $checked)\;</script></td>\n";
	    $div .= "    <font face=\"Monospace\"><td valign=\"middle\" align=\"center\">$i</td><td valign=\"middle\" align=\"center\">$Cscore{$i}</td><td valign=\"middle\"><a href=\"../../../BioLiP/qsearch.cgi?pdbid=$pdbcode\" target=\"_blank\">$hits{$i}</a></font></td><td align=\"center\">$T_tmscore{$i}</td><td valign=\"middle\" align=\"center\">$T_rmsd{$i}</td><td valign=\"middle\" align=\"center\">$T_iden{$i}</td><td valign=\"middle\">$T_cov{$i}</td><td valign=\"middle\" align=\"center\">$BS_score{$i}</td><td>$ligname</td><td align=center><a href=\"protein/cofactor/complex$i.pdb\"><font face=\"Arial\">Download</font></a></td><td valign=\"middle\">$pbsr</td></tr>\n";
        }
    }
    close(RESULT);
  loopout1:;
    $div    .="       </table>\n";
    $div    .="       <br/>\n";
    $div    .="       <table  cellspacing=\"2\" border=\"0\" style=\"font-family:Arial;font-size:12px;\">\n";

    $div    .="        <tr><td valign=\"top\">(a)</td><td align=\"justify\"><b>C-score</b> is the confidence score of predicted binding site. C-score values range in between [0-1]; where a higher score indicates a more reliable prediction. </td></tr>\n";

    $div    .= "       <tr><td valign=\"top\">(b)</td><td align=\"justify\"><b>RMSD<sup></b> the RMSD between residues that are structurally aligned by TM-align.</td></tr>\n";
    $div    .= "       <tr><td valign=\"top\">(c)</td><td align=\"justify\"><b>IDEN</b> is the percentage sequence identity in the structurally aligned region.</td></tr>\n";

    $div    .= "       <tr><td valign=\"top\">(d)</td><td align=\"justify\"><b>Cov</b> represents the coverage of global structural alignment and is equal to the number of structurally aligned residues divided by length of the query protein.</td></tr>\n";

    $div    .= "       <tr><td valign=\"top\">(e)</td><td align=\"justify\"><b>BS-score</b> is a measure of local similarity (sequence & structure) between template binding site and predicted binding site in the query structure. Based on large scale benchmarking analysis, we have observed that a BS-score >1 reflects a significant local match between the predicted and template binding site.\n";


    $div    .= "       </table></td></tr>\n";
  nobs:;
    $div    .= "     </table>\n";
    $div    .= "   </td></tr></table>\n";
    $div    .= "  </div>\n";
    $div    .= "</td></tr>\n";


    $div    .="
     </div>     
</div>
</td></tr>
";

    
    return($div, $conf, $results);
}


sub makeTMSITEdiv
{
    my($dir1, $model, $dir2, $filename, $sequence, $bin, $www)=@_;      
    my $MAXP= 5;
    my $div ='';    
    my %ts=(
        'ALA'=>'A', 'ARG'=>'R', 'ASN'=>'N', 'ASP'=>'D', 'CYS'=>'C', 'GLN'=>'Q', 'GLU'=>'E', 'GLY'=>'G',
        'HIS'=>'H', 'ILE'=>'I', 'LEU'=>'L', 'LYS'=>'K', 'MET'=>'M', 'PHE'=>'F', 'PRO'=>'P', 'SER'=>'S',
        'THR'=>'T', 'TRP'=>'W', 'TYR'=>'Y', 'VAL'=>'V', 'ASX'=>'N', 'GLX'=>'Q', 'UNK'=>'G',
        'A'=>'ALA', 'R'=>'ARG', 'N'=>'ASN', 'D'=>'ASP', 'C'=>'CYS', 'Q'=>'GLN', 'E'=>'GLU', 'G'=>'GLY',
        'H'=>'HIS', 'I'=>'ILE', 'L'=>'LEU', 'K'=>'LYS', 'M'=>'MET', 'F'=>'PHE', 'P'=>'PRO', 'S'=>'SER',
        'T'=>'THR', 'W'=>'TRP', 'Y'=>'TYR', 'V'=>'VAL', 'B'=>'ASX', 'Z'=>'GLX', 'X'=>'UNK');

   

    my $results="";


    $div ='';
    $div    .= "

<tr> <td>
<div id=\"headerDiv\">
     <div id=\"titleText\">TM-SITE Results</div>
      <a id=\"TMHeader\" href=\"javascript:toggle2('TMContent','TMHeader');\" >Hide</a>
</div>
<div style=\"clear:both;\"></div>
<div id=\"contentDiv\">
     <div id=\"TMContent\" style=\"display: block;\">";
   

    $div   .= "   <div style=\"position:relative; background:#F2F2F2;width:100%\">\n";
    $div   .= "       <table border=\"0\" style=\"background:#F2F2F2;align=\"left\" cellpadding=\"10\">\n";


    if(!-s "$dir2/$filename")
    {
        $div    .= "    <td><b>No binding site was predicted by TM-SITE.</b></td></tr>\n";
	$results .= "    <tr bgcolor=\"#DEDEDE\"><td><b>TM-SITE</b></td><td></td><td></td><td>No binding site was predicted by TM-SITE.</td></tr>\n";
        goto nobs;
    }



    my %xs=(); my %ys=();  my %zs=();
    open(PDB,"$dir1/$model");
    while(my $line2=<PDB>)
    {
	my $record     = substr($line2,0,6);
	if($record eq "ATOM  ")
	{
	    my $atom_name = substr($line2,12,4);
	    my $res_no    = substr($line2,22,4);$res_no    =~s/\s+//;
	    if($atom_name eq ' CA ' || $atom_name eq '  CA' || $atom_name eq 'CA  ')
	    {
		$xs{$res_no} =substr($line2,30,8);
		$ys{$res_no} =substr($line2,38,8);
		$zs{$res_no} =substr($line2,46,8);
	    }
	}
    }
    close(PDB);
    my $firstbs='';    
    my $conf=0;
    
    my %pbs=();    
    my @pred=();
    
    my @temp=();
    my $topN=0;
    my $tot_pred=0;

    
    open(RESULT,"<$dir2/$filename");
    while(my $line = <RESULT>)
    {
	if(!($line =~ /\d+/))
	{	    
	    next;
	}

	chomp($line);

	$topN++;	    
	if($topN > $MAXP)
	{
	    last;
	}
	
	if($line =~/\S+\t(\S+)\t\S+\t(\S+)\t(\S+)\t(.+)/)
	{
	    my $cscore=$1;
	    my $repTemp=$2;
	    my $pbsr=$3;
	    my $ligands=$4;
	    my @pred = split(/,/, $pbsr);		    

	    my $nTemp=0;
	    my @lig=split(/\s+/, $ligands);
	    my $alllig="";
	    for(my $i=0; $i<$#lig; $i=$i+2)
	    {				
		if($lig[$i+1] =~ /\d+/)
		{
		    $nTemp += $lig[$i+1];
		}

		$alllig .= "<a href=../../../BioLiP/sym.cgi?code=$lig[$i] target=\"_blank\">$lig[$i]</a>($lig[$i+1]),";

		if($i>=4 && $i<@lig-2)
		{
		    $alllig .= "...";
		    last;
		}
	    }
	    $alllig =~ s/\s+$//g;
	    chop($alllig);	    

	    $pbs{$topN, 0}=$cscore;
	    $pbs{$topN, 1}=$nTemp;
	    $pbs{$topN, 2}=$repTemp;
	    push @{$pbs{$topN, 3}}, @pred;
	    $pbs{$topN, 4}=$alllig;
	}
    }
    close(RESULT);

    #display TM-SITE prediction on html


    my @firstres = @{$pbs{1, 3}};
    my $fres     = join(',', @{$pbs{1, 3}});

    my $repTemp=$pbs{1, 2};

    if($repTemp =~ /NUC/)
    {
	$div    .="       <tr><td align =\"center\"><script type=\"text/javascript\">jmolInitialize(\"../../jmol/\")\;jmolSetAppletColor(\"#000000\")\;jmolApplet(500, \"load $modelname/tmsite/complex1_$repTemp.pdb; set frank off; select all; spacefill off; wireframe off; cartoons; select hetero; spacefill 95\%; set radius 1.0; color greenyellow;  set ambient 40; select $fres; wireframe 75; spacefill 100; color blue;";
    }
    else
    {
	$div    .="       <tr><td align =\"center\"><script type=\"text/javascript\">jmolInitialize(\"../../jmol/\")\;jmolSetAppletColor(\"#000000\")\;jmolApplet(500, \"load $modelname/tmsite/complex1_$repTemp.pdb; set frank off; select all; spacefill off; wireframe off; cartoons; select hetero; spacefill 95\%; set radius 1.0; color greenyellow;  set ambient 40; select $fres; wireframe 75; spacefill 100; color blue;";
    }

    foreach my $r(@firstres)
    {
	$div .= "select $r and \*.ca; label %m%r; color label magenta;";   	
    }	           	    	

    $div     .="     set spin x 10; set spin y 10; spin off;\");</script><br/><SCRIPT>jmolCheckbox(\"set spin x 10; set spin y 10; spin on\", \"spin off\", \"Spin On/Off\", false)</SCRIPT>
</td>\n";
	$div    .="       <td valign=\"top\">";
    $div    .="       <table border=\"0\"  style=\"font-family:Arial;font-size:13px;\"><tr bgcolor=\"#DEDEDE\"><th>Click to view</th><th>Rank</th><th>C-score<sup>a</sup></th><th>Cluster<br/>size<sup>b</sup></th> <th>Rep<br>Templ<sup>c</sup></th> <th>Mult<br>Templ<sup>d</sup></th> <th>Ligands<sup>e</sup></th> <th>Predicted binding site residues</th> </tr>\n";   
   
       
    for(my $i=1; $i<=$topN; $i++)
    {
	if($i > $MAXP)
	{
	    last;
	}
	

	my $bgcolor="";
	if($i%2==0)
	{
	    #$bgcolor="bgcolor=\"#F0FFF0\"";
	    $bgcolor="bgcolor=\"#DEDEDE\"";
	    #$bgcolor="bgcolor=white";
	}

	my $checked="false";

	my $cscore= sprintf("%.2f", $pbs{$i, 0});
	my @res=@{$pbs{$i, 3}};
	my $res1=join(',', @res);

	$repTemp=$pbs{$i, 2};

	if($i==1)
	{
	    $conf=$cscore;
	}

	if($i==1)
	{
	    $results .= "<tr bgcolor=\"#DEDEDE\"><td> <b>TM-SITE</b> </td><td>$i</td><td>$cscore</td><td>$res1</td></tr>";
	}
	else
	{
	    $results .= "<tr><td></td><td>$i</td><td>$cscore</td><td>$res1</td></tr>";
	}
	

	my $size=$pbs{$i, 1};


	$div .= "       <tr $bgcolor>\n";



	$div .= "       <td align=\"center\"><script language=\"JavaScript\" type=\"text/javascript\">jmolRadio(\"load $modelname/tmsite/complex$i\_$repTemp.pdb;; set frank off; select all;  spacefill off; wireframe off; cartoons; select $res1; wireframe 75; spacefill 100; color blue;";

		    
	foreach my $r(@res)
	{
	    $div .= "select $r and \*.ca; label %m%r; color label magenta;";
	}
	    	    
	if($repTemp =~ /NUC/)
	{
	    $div .= " select hetero; color greenyellow; spacefill;  spacefill off; wireframe off; spacefill off; set ambient 40;  ";
	}
	else
	{
	    $div .= " select hetero; spacefill 95\%; set radius 0.90; color greenyellow; set ambient 40;";
	}


	$div .= "    set spin x 5; set spin y 5; spin off;\", \"\", $checked)\;</script></td>\n";

	$div .= "    <font face=\"Monospace\"><td valign=\"middle\" align=\"center\">$i</td><td valign=\"middle\" align=\"center\">$cscore</td> <td valign=\"middle\" align=\"center\">$size</td> <td valign=\"middle\" align=\"middle\"><a href=$modelname/tmsite/complex$i\_$repTemp.pdb>$repTemp</a></td>  <td valign=\"middle\" align=\"middle\"><a href=$modelname/tmsite/complex$i.pdb>Download</a></td> <td valign=\"middle\" align=\"left\">$pbs{$i, 4}</td>      <td valign=\"middle\" align=\"left\">$res1</td>    </tr>\n";        
    } 

  loopout1:;
    $div    .="       </table>\n";
    $div    .="       <br/>\n";
    $div    .="       <table  cellspacing=\"2\" border=\"0\" style=\"font-family:Arial;font-size:12px;\">\n";

    $div    .="        <tr><td valign=\"top\">(a)</td><td align=\"justify\"><b>C-score</b> is the confidence score of predicted binding site. C-score ranges [0-1], where a higher score indicates a more reliable prediction. </td></tr>\n";
    $div    .= "       <tr><td valign=\"top\">(b)</td><td align=\"justify\"><b>Cluster size</b> is the number of templates in a cluster.\n";

    $div    .= "       <tr><td valign=\"top\">(c)</td><td align=\"justify\"><b>Rep Templ</b> presents a representaive ligand-protein template from a cluster. The template names are: (PDBIDchain)_(BioLiP site #)_(Ligand ID). Click the corresponding template to download the structure.\n";

    $div    .= "       <tr><td valign=\"top\">(d)</td><td align=\"justify\"><b>Mult Templ</b> provides all ligand-protein complex structures in a cluster, where each ligand is separated by \"TER\".\n";

    $div    .= "       <tr><td valign=\"top\">(e)</td><td align=\"justify\"><b>Ligands</b> lists all ligands in a cluster. The numbers in the parentheses are the appearing times of the corresponding ligands. Click the ligand name to visualize its detailed information in BioLiP.\n";

    $div    .= "       </table></td></tr>\n";
  nobs:;
    $div    .= "     </table>\n";
    $div    .= "   </td></tr></table>\n";
    $div    .= "  </div>\n";
    $div    .= "</td></tr>\n";


    $div    .="
     </div>     
</div>
</td></tr>
";

    return($div, $conf, $results);
}



sub makeSSITEdiv
{
    my($dir1, $model, $dir2, $filename, $sequence, $bin, $www)=@_;      
    my $MAXP= 5;
    my $div ='';    
    my %ts=(
        'ALA'=>'A', 'ARG'=>'R', 'ASN'=>'N', 'ASP'=>'D', 'CYS'=>'C', 'GLN'=>'Q', 'GLU'=>'E', 'GLY'=>'G',
        'HIS'=>'H', 'ILE'=>'I', 'LEU'=>'L', 'LYS'=>'K', 'MET'=>'M', 'PHE'=>'F', 'PRO'=>'P', 'SER'=>'S',
        'THR'=>'T', 'TRP'=>'W', 'TYR'=>'Y', 'VAL'=>'V', 'ASX'=>'N', 'GLX'=>'Q', 'UNK'=>'G',
        'A'=>'ALA', 'R'=>'ARG', 'N'=>'ASN', 'D'=>'ASP', 'C'=>'CYS', 'Q'=>'GLN', 'E'=>'GLU', 'G'=>'GLY',
        'H'=>'HIS', 'I'=>'ILE', 'L'=>'LEU', 'K'=>'LYS', 'M'=>'MET', 'F'=>'PHE', 'P'=>'PRO', 'S'=>'SER',
        'T'=>'THR', 'W'=>'TRP', 'Y'=>'TYR', 'V'=>'VAL', 'B'=>'ASX', 'Z'=>'GLX', 'X'=>'UNK');

  



    $div ='';
    $div    .= "

<tr> <td>
<div id=\"headerDiv\">
     <div id=\"titleText\">S-SITE Results</div>
      <a id=\"SHeader\" href=\"javascript:toggle2('SContent','SHeader');\" >Hide</a>
</div>
<div style=\"clear:both;\"></div>
<div id=\"contentDiv\">
     <div id=\"SContent\" style=\"display: block;\">";
   

    $div   .= "   <div style=\"position:relative; background:#F2F2F2;width:100%\">\n";
    $div   .= "       <table border=\"0\" style=\"background:#F2F2F2;align=\"left\" cellpadding=\"10\">\n";








    my $results="";


    if(!-s "$dir2/$filename")
    {
        $div    .= "    <td><b>No binding site was predicted by S-SITE.</b></td></tr>\n";
	$results .= "    <tr bgcolor=\"#DEDEDE\"><td><b>S-SITE</b></td><td></td><td></td><td>No binding site was predicted by S-SITE.</td></tr>\n";
        goto nobs;
    }



    my %xs=(); my %ys=();  my %zs=();
    open(PDB,"$dir1/$model");
    while(my $line2=<PDB>)
    {
	my $record     = substr($line2,0,6);
	if($record eq "ATOM  ")
	{
	    my $atom_name = substr($line2,12,4);
	    my $res_no    = substr($line2,22,4);$res_no    =~s/\s+//;
	    if($atom_name eq ' CA ' || $atom_name eq '  CA' || $atom_name eq 'CA  ')
	    {
		$xs{$res_no} =substr($line2,30,8);
		$ys{$res_no} =substr($line2,38,8);
		$zs{$res_no} =substr($line2,46,8);
	    }
	}
    }
    close(PDB);
    my $firstbs='';    



    #load SSITE prediction



    my %pbs=();    
    my @pred=();
    my @temp=();
    my $topN=0;
    my $tot_pred=0;
    my $cscore=0.00;

 
    my $n=0;
    open(RESULT,"<$dir2/Bsites_dis.clr");
    while(my $line = <RESULT>)
    {
	chomp($line);
	if($line=~/^cluster/)
	{
	    $n++;	    
	}
	else
	{
	    if($line =~ /(\S+)/)
	    {
		push(@{$pbs{$n, 2}}, $1);
	    }
	}
    }
    close(RESULT);


    open(RESULT,"<$dir2/$filename");
    while(my $line = <RESULT>)
    {
	chomp($line);
	if($line !~ /\t/)
	{
	    next;
	}
	$topN++;	    
	if($topN > $MAXP)
	{
	    last;
	}
	
	if($line =~ /(\S+)\t\S+\t\S+\t\S+\t\S+\t(\S+)\t(.+)/)
	{
	    $pbs{$topN, 0}=$1;
	    $pbs{$topN, 1}=$2;

	    my $ligands=$3;
	    my $nTemp=0;
	    my @lig=split(/\s+/, $ligands);
	    my $alllig="";
	    for(my $i=0; $i<$#lig; $i=$i+2)
	    {				
		if($lig[$i+1] =~ /\d+/)
		{
		    $nTemp += $lig[$i+1];
		}

		$alllig .= "<a href=../../../BioLiP/sym.cgi?code=$lig[$i] target=\"_blank\">$lig[$i]</a>($lig[$i+1]),";

		if($i>=4 && $i<@lig-2)
		{
		    $alllig .= "...";
		    last;
		}
	    }
	    $alllig =~ s/\s+$//g;
	    chop($alllig);
	    $pbs{$topN, 3}=$alllig;
	}
    }
    close(RESULT);


    #display TMSITE prediction on html


    my @firstres = split(/,/, $pbs{1, 1});
    my $fres     = $pbs{1, 1};

    

    $div    .="       <tr><td align =\"center\"><script type=\"text/javascript\">jmolInitialize(\"../../jmol/\")\;jmolSetAppletColor(\"#000000\")\;jmolApplet(500, \"load protein.pdb; set frank off; select all; spacefill off; wireframe off; cartoons;  select $fres; wireframe 75; spacefill 100; color blue;";
      
    foreach my $r(@firstres)
    {
	$div .= "select $r and \*.ca; label %m%r; color label magenta;";  
    }	
    	
    $div     .="     set spin x 10; set spin y 10; spin off;\");</script><br/><SCRIPT>jmolCheckbox(\"set spin x 10; set spin y 10; spin on\", \"spin off\", \"Spin On/Off\", false)</SCRIPT>
</td>\n";
	$div    .="       <td valign=\"top\">";
    $div    .="       <table border=\"0\"  style=\"font-family:Arial;font-size:13px;\"><tr bgcolor=\"#DEDEDE\"> <th>Click to view</th> <th>Rank</th>  <th>C-score<sup>a</sup></th><th>Cluster<br>size<sup>b</sup></th>  <th>Templates<sup>c</sup></th>  <th valign=\"middle\">Ligands<sup>d</sup></th>     <th>Predicted binding site residues</th>   </tr>\n";   
   
       
    for(my $i=1; $i<=$topN; $i++)
    {
	if($i > $MAXP)
	{
	    last;
	}	

	my $bgcolor="";
	if($i%2==0)
	{
	    #$bgcolor="bgcolor=\"#F0FFF0\"";
	    $bgcolor="bgcolor=\"#DEDEDE\"";
	    #$bgcolor="bgcolor=white";
	}

	my $checked="false";

	my $cscore=$pbs{$i, 0};
	my @res=split(/,/, $pbs{$i, 1});
	my $res1=join(',', @res);


	if($i==1)
	{
	    $results .= "<tr bgcolor=\"#DEDEDE\"><td><b>S-SITE</b></td><td>$i</td><td>$cscore</td><td>$res1</td></tr>";
	}
	else
	{
	    $results .= "<tr><td></td><td>$i</td><td>$cscore</td><td>$res1</td></tr>";
	}
	
	my @temp=@{$pbs{$i, 2}};
	open(TMP, ">$dir2/templates_$i.lst");
	print TMP join("\n", @temp);
	close(TMP);

	my $nt=0;	
	my $templates .= "<a href=ssite/templates_$i.lst target=\"_blank\">List</a>";		
	my $size=@temp;
	my $comx=0; my $comy=0;  my $comz=0;	  

	$div .= "       <tr $bgcolor>\n"; 

	$div .= "       <td align=\"center\"><script language=\"JavaScript\" type=\"text/javascript\">jmolRadio(\"load protein.pdb; set frank off; select all; spacefill off; wireframe off; cartoons; select hetero; spacefill 95\%; set radius 0.90; color cpk; set ambient 40; select $res1; wireframe 75; spacefill 100; color blue;";


	foreach my $r(@res)
	{
	    $div .= "select $r and \*.ca; label %m%r; color label magenta;";
	}    	    
	$div .= "    set spin x 5; set spin y 5; spin off;\", \"\", $checked)\;</script></td>\n";




	$div .= "    <font face=\"Monospace\">  <td align=\"center\">$i</td>  <td valign=\"middle\" align=\"center\">$cscore</td> <td valign=\"middle\" align=\"center\">$size</td>  <td valign=\"middle\" align=center>$templates</td>   <td valign=\"middle\" align=\"left\">$pbs{$i, 3}</td>      <td valign=\"middle\" align=\"left\">$res1</td>  </tr>\n";        
    } 

  loopout1:;
    $div    .="       </table>\n";
    $div    .="       <br/>\n";
    $div    .="       <table  cellspacing=\"2\" border=\"0\" style=\"font-family:Arial;font-size:12px;\">\n";

    $div    .="        <tr><td valign=\"top\">(a)</td><td align=\"justify\"><b>C-score</b> is the confidence score of predicted binding site. C-score ranges [0-1], where a higher score indicates a more reliable prediction. </td></tr>\n";
    $div    .= "       <tr><td valign=\"top\">(b)</td><td align=\"justify\"><b>Cluster size</b> is the number of templates in a cluster.\n";

    $div    .= "       <tr><td valign=\"top\">(c)</td><td align=\"justify\"><b>Templates</b> presents the list of templates in a cluster. The template names are: (PDBIDchain)_(BioLiP site #)_(Ligand ID). Click the corresponding template to search the BioLiP database. When the number of templates is >5, click \"show all templates\" to get the list of all templates in the cluster\n";

    $div    .= "       <tr><td valign=\"top\">(d)</td><td align=\"justify\"><b>Ligands</b> lists ligands in a cluster. The numbers in the parentheses are the appearing times for the corresponding ligands. Click the ligand name to visualize its detailed information in BioLiP.\n";





    $div    .= "       </table></td></tr>\n";
  nobs:;
    $div    .= "     </table>\n";
    $div    .= "   </td></tr></table>\n";
    $div    .= "  </div>\n";
    $div    .= "</td></tr>\n";


    $div    .="
     </div>     
</div>
</td></tr>
";

    return($div, $conf, $results);
}



sub makeFINDSITEdiv
{
    my($dir1, $model, $dir2, $filename, $sequence, $bin, $www)=@_;      
    my $MAXP= 5;
    my $div ='';    
    my %ts=(
        'ALA'=>'A', 'ARG'=>'R', 'ASN'=>'N', 'ASP'=>'D', 'CYS'=>'C', 'GLN'=>'Q', 'GLU'=>'E', 'GLY'=>'G',
        'HIS'=>'H', 'ILE'=>'I', 'LEU'=>'L', 'LYS'=>'K', 'MET'=>'M', 'PHE'=>'F', 'PRO'=>'P', 'SER'=>'S',
        'THR'=>'T', 'TRP'=>'W', 'TYR'=>'Y', 'VAL'=>'V', 'ASX'=>'N', 'GLX'=>'Q', 'UNK'=>'G',
        'A'=>'ALA', 'R'=>'ARG', 'N'=>'ASN', 'D'=>'ASP', 'C'=>'CYS', 'Q'=>'GLN', 'E'=>'GLU', 'G'=>'GLY',
        'H'=>'HIS', 'I'=>'ILE', 'L'=>'LEU', 'K'=>'LYS', 'M'=>'MET', 'F'=>'PHE', 'P'=>'PRO', 'S'=>'SER',
        'T'=>'THR', 'W'=>'TRP', 'Y'=>'TYR', 'V'=>'VAL', 'B'=>'ASX', 'Z'=>'GLX', 'X'=>'UNK');

   
    $div ='';
    $div    .= "

<tr> <td>
<div id=\"headerDiv\">
     <div id=\"titleText\">FINDSITE Results</div>
      <a id=\"FHeader\" href=\"javascript:toggle2('FContent','FHeader');\" >Hide</a>
</div>
<div style=\"clear:both;\"></div>
<div id=\"contentDiv\">
     <div id=\"FContent\" style=\"display: block;\">";
   

    $div   .= "   <div style=\"position:relative; background:#F2F2F2;width:100%\">\n";
    $div   .= "       <table border=\"0\" style=\"background:#F2F2F2;align=\"left\" cellpadding=\"10\">\n";




    my $results="";
    my $conf=0;

    if(!-s "$dir2/$filename")
    {
        $div    .= "    <td><b>No binding site was predicted by FINDSITE.</b></td></tr>\n";
	$results .= "    <tr bgcolor=\"#DEDEDE\"><td><b>FINDSITE</b></td><td></td><td></td><td>No binding site was predicted by FINDSITE.</td></tr>\n";
        goto nobs;
    }


    #&findsite_ligands($dir2);

    #`scp $dir2/complex* $dir2/ligands*.sdf zhanglabs\@zhanglab.ccmb.med.umich.edu:$wwwloc/protein/findsite/`;


    my %xs=(); my %ys=();  my %zs=();
    open(PDB,"$dir1/$model");
    while(my $line2=<PDB>)
    {
	my $record     = substr($line2,0,6);
	if($record eq "ATOM  ")
	{
	    my $atom_name = substr($line2,12,4);
	    my $res_no    = substr($line2,22,4);$res_no    =~s/\s+//;
	    if($atom_name eq ' CA ' || $atom_name eq '  CA' || $atom_name eq 'CA  ')
	    {
		$xs{$res_no} =substr($line2,30,8);
		$ys{$res_no} =substr($line2,38,8);
		$zs{$res_no} =substr($line2,46,8);
	    }
	}
    }
    close(PDB);
    my $firstbs='';    



    #load FINDSITE prediction

    my $nt=0;
    open(FINp, "<$dir2/protein.pockets.pdb");
    while(my $line = <FINp>)
    {
	if($line =~ /PKT M\s+(\d+)\s+/)	
	{
	    $nt += $1;
	}
    }
    close(FINp);

    my %pbs=();    
    my @pred=();
    my @temp=();
    my $topN=0;
    my $tot_pred=0;
    my $cscore=0;
    my %case=();
    my $cn=0;
    open(RESULT,"<$dir2/$filename");
    while(my $line = <RESULT>)
    {
	if($line =~ /^POCKET\s+(\d+)\s+\d+\s+(\S+)/)
        {
	    $cscore=$2;
	    if($nt==1 && $cscore>0.9)
	    {
		$cscore=0.05;
	    }
            $topN++;
	    $cn++;
            if($topN > $MAXP)
            {
                last;
            }
        }
	
	if($line =~ /^LIGAND\s+\d+\s*(\S+)\s*/)
	{
	    push(@temp, $1);
	}

        if($line =~ /^TER/) ##compute MCC
        {
	    if(@pred==0)
	    {
		$topN--;
		$case{$cn}=0;
		next;
	    }
	    else
	    {
		$case{$cn}=1;
	    }	   

	    $pbs{$topN, 0}=$cscore;
	    push @{$pbs{$topN, 1}}, @pred;
	    push @{$pbs{$topN, 2}}, @temp;
	    @pred=();
	    @temp=();
	}

        if($line =~ /^RESIDUE/)
        {
	    my $res_no      = substr($line, 7, 6);  $res_no =~ s/\s+//;
	    my $prob        = substr($line, 31, 8); $prob   =~ s/\s+//;   	   
	    if($prob>=0.25)
	    {
		push(@pred, $res_no);
	    }
        }
    }
    close(RESULT);

    &findsite_ligands($dir2, \%case);






    #display FINDSITE prediction on html


    my @firstres=@{$pbs{1, 1}};
    my $fres=join(',', @{$pbs{1, 1}});


    $div    .="       <tr><td align =\"center\"><script type=\"text/javascript\">jmolInitialize(\"../../jmol/\")\;jmolSetAppletColor(\"#000000\")\;jmolApplet(500, \"load protein/findsite/complex1.pdb; set frank off; select all; spacefill off; wireframe off; cartoons; select hetero; spacefill 95\%; set radius 1.0; color greenyellow;  set ambient 40; select $fres; wireframe 75; spacefill 100; color blue;";

       
    foreach my $r(@firstres)
    {
	$div .= "select $r and \*.ca; label %m%r; color label magenta;";
    }
    $div     .="     set spin x 10; set spin y 10; spin off;\");</script><br/><SCRIPT>jmolCheckbox(\"set spin x 10; set spin y 10; spin on\", \"spin off\", \"Spin On/Off\", false)</SCRIPT>
</td>\n";
	$div    .="       <td valign=\"top\">";
    $div    .="       <table border=\"0\"  style=\"font-family:Arial;font-size:13px;\"><tr bgcolor=\"#DEDEDE\"><th>Click to view</th><th>Rank</th><th>C-score<sup>a</sup></th><th>Cluster<br/>size<sup>b</sup></th><th>Rep<br>Templ<sup>c</sup></th>  <th>Multi<br>Templ<sup>d</sup></th>  <th> Ligands<sup>e</sup></th>   <th>Predicted binding site residues</th>  </tr>\n";   
    
       
    for(my $i=1; $i<=$topN; $i++)
    {
	if($i > $MAXP)
	{
	    last;
	}
	

	my $bgcolor="";
	if($i%2==0)
	{
	    #$bgcolor="bgcolor=\"#F0FFF0\"";
	    $bgcolor="bgcolor=\"#DEDEDE\"";
	    #$bgcolor="bgcolor=white";
	}

	my $checked="false";

	my $cscore=sprintf("%.2f", $pbs{$i, 0});
	if($i==1)
	{
	    $conf=$cscore;
	}

	my @res=@{$pbs{$i, 1}};
	my $res1=join(',', @res);
	
	if($i==1)
	{
	    $results .= "<tr bgcolor=\"#DEDEDE\"><td><b>FINDSITE</b></td><td>$i</td><td>$cscore</td><td>$res1</td></tr>";
	}
	else
	{
	    $results .= "<tr><td></td><td>$i</td><td>$cscore</td><td>$res1</td></tr>";
	}


	my $cut=0;
	my @temp=@{$pbs{$i, 2}};

	open(TMP, ">$dir2/templates_$i.lst");
	print TMP join("\n", @temp);
	close(TMP);
	#`scp $dir2/templates_$i.lst zhanglabs\@zhanglab.ccmb.med.umich.edu:$wwwloc/protein/findsite/`;
	
	my $nt=0;
	my $representative="<a href=protein/findsite/complex$i.pdb>$temp[0]</a>";
	my $ligands = "<a href=protein/findsite/ligands$i.sdf>download</a>";
	my $templates .= "<a href=protein/findsite/templates_$i.lst target=\"_blank\">List</a>";
	my $size=@temp;
	$div .= "       <tr $bgcolor>\n";

	$div .= "       <td align=\"center\"><script language=\"JavaScript\" type=\"text/javascript\">jmolRadio(\"load protein/findsite/complex$i.pdb; set frank off; select all; spacefill off; wireframe off; cartoons; select hetero; spacefill 95\%; set radius 0.90; color greenyellow; set ambient 40; select $res1; wireframe 75; spacefill 100; color blue;";

	    
	foreach my $r(@res)
	{
	    $div .= "select $r and \*.ca; label %m%r; color label magenta;";
	}	    	    
	$div .= "    set spin x 5; set spin y 5; spin off;\", \"\", $checked)\;</script></td>\n";



	$div .= "    <font face=\"Monospace\"><td valign=\"middle\" align=\"center\">$i</td><td valign=\"middle\" align=\"center\">$cscore</td> <td valign=\"middle\" align=\"center\">$size</td> <td valign=\"middle\" align=\"middle\">$representative</td>    <td valign=\"middle\" align=\"middle\">$templates</td> <td valign=\"middle\" align=\"middle\">$ligands</td>  <td valign=\"middle\" align=\"left\">$res1</td> </tr>\n";        
    } 


  loopout1:;
    $div    .="       </table>\n";
    $div    .="       <br/>\n";
    $div    .="       <table  cellspacing=\"2\" border=\"0\" style=\"font-family:Arial;font-size:12px;\">\n";

    $div    .="        <tr><td valign=\"top\">(a)</td><td align=\"justify\"><b>C-score</b> is the confidence score of predicted binding site. C-score values range in between [0-1]; where a higher score indicates a more reliable prediction. </td></tr>\n";
    $div    .= "       <tr><td valign=\"top\">(b)</td><td align=\"justify\"><b>Cluster size</b> is the number of templates in a cluster\n";

    $div    .= "       <tr><td valign=\"top\">(c)</td><td align=\"justify\"><b>Rep Templ</b> presents a representaive ligand-protein template from a cluster. The template names are: (PDBID)(chain)(Ligand #). The ligands have been renamed by FINDSITE as 2-digit numbers. Click the corresponding template to download the structure.\n";

    $div    .= "       <tr><td valign=\"top\">(d)</td><td align=\"justify\"><b>Mult Templ</b> provides the list of all templates in a cluster.\n";

    $div    .= "       <tr><td valign=\"top\">(e)</td><td align=\"justify\"><b>Ligands</b> presents the structures of all ligands in a cluster.\n";


    $div    .= "       </table></td></tr>\n";
  nobs:;
    $div    .= "     </table>\n";
    $div    .= "   </td></tr></table>\n";
    $div    .= "  </div>\n";
    $div    .= "</td></tr>\n";


    $div    .="
     </div>     
</div>
</td></tr>
";

    return($div, $conf, $results);
}

sub findsite_ligands
{
    my ($dir, $case_ref)=@_;
    my %case=%$case_ref;
    
    open(LIG, "$dir/protein.ligands.sdf");
    my %lig=();
    my @lig1=();
    my $poc=1;
    my $tot=1;
    while(my $line=<LIG>)
    {
	push(@lig1, $line);
	if($line =~ /\$\$\$\$/)
	{	    
	    push(@{$lig{$poc}}, @lig1);
	    @lig1=();
	}
	
	if($line =~ /FINDSITE_POCKET/)
	{
	    $line=<LIG>;
	    push(@lig1, $line);
	    chomp($line);
	    $poc=$line;	 	    
	}
    }
    close(LIG);
    $tot=$poc;

    #$tot=5 if($tot>5);
    
    `cp $datadir/protein.pdb temp.pdb`;
    my $i1=1;
    for(my $i=1; $i<=$tot; $i++)
    {
	if(!exists $case{$i1} || $case{$i1}==0)
	{
	    next;
	}
	
	@lig1=@{$lig{$i}};
	open(FLIG, ">ligands$i1.sdf");
	foreach my $r(@lig1)
	{
	    print FLIG "$r";
	}
	close(FLIG);
	`babel ligands$i1.sdf ligands.pdb`;
	my @pdb=`cat ligands.pdb`;

	open(FLIG, ">ligands.pdb");
	print FLIG "TER\n";
	foreach my $line(@pdb)
	{
	    if($line=~/^HETATM/ || $line=~/^ATOM/)
	    {
		substr($line, 0, 6)="HETATM";
		print FLIG $line;
	    }

	    if($line =~ /^ENDMDL/)
	    {
		print FLIG "TER\n";
		last;
	    }
	}
	close(FLIG);		
		

	`cat temp.pdb ligands.pdb >complex$i1.pdb`;
	`mv complex$i1.pdb $dir/`;
	`mv ligands$i1.sdf $dir/`;

	$i1++;
	
    }

    `rm -f temp.pdb ligands.pdb`;    
}




sub makeConCavitydiv
{
    my($dir1, $model, $dir2, $filename, $sequence, $bin, $www)=@_;      
    my $MAXP= 5;
    my $div ='';    
    my %ts=(
        'ALA'=>'A', 'ARG'=>'R', 'ASN'=>'N', 'ASP'=>'D', 'CYS'=>'C', 'GLN'=>'Q', 'GLU'=>'E', 'GLY'=>'G',
        'HIS'=>'H', 'ILE'=>'I', 'LEU'=>'L', 'LYS'=>'K', 'MET'=>'M', 'PHE'=>'F', 'PRO'=>'P', 'SER'=>'S',
        'THR'=>'T', 'TRP'=>'W', 'TYR'=>'Y', 'VAL'=>'V', 'ASX'=>'N', 'GLX'=>'Q', 'UNK'=>'G',
        'A'=>'ALA', 'R'=>'ARG', 'N'=>'ASN', 'D'=>'ASP', 'C'=>'CYS', 'Q'=>'GLN', 'E'=>'GLU', 'G'=>'GLY',
        'H'=>'HIS', 'I'=>'ILE', 'L'=>'LEU', 'K'=>'LYS', 'M'=>'MET', 'F'=>'PHE', 'P'=>'PRO', 'S'=>'SER',
        'T'=>'THR', 'W'=>'TRP', 'Y'=>'TYR', 'V'=>'VAL', 'B'=>'ASX', 'Z'=>'GLX', 'X'=>'UNK');

   

    $div ='';
    $div    .= "

<tr> <td>
<div id=\"headerDiv\">
     <div id=\"titleText\">ConCavity Results</div>
      <a id=\"CavHeader\" href=\"javascript:toggle2('CavContent','CavHeader');\" >Hide</a>
</div>
<div style=\"clear:both;\"></div>
<div id=\"contentDiv\">
     <div id=\"CavContent\" style=\"display: block;\">";
   

    $div   .= "   <div style=\"position:relative; background:#F2F2F2;width:100%\">\n";
    $div   .= "       <table border=\"0\" style=\"background:#F2F2F2;align=\"left\" cellpadding=\"10\">\n";



    my $results="";




    if(!-s "$dir2/$filename")
    {
        $div    .= "    <td><b>No binding site was predicted by ConCavity.</b></td></tr>\n";
	$results .= "    <tr bgcolor=\"#DEDEDE\"><td><b>ConCavity</b></td><td></td><td></td><td>No binding site was predicted by ConCavity.</td></tr>\n";
        goto nobs;
    }



    my $firstbs='';    



    #load ConCavity prediction
    my %pbs=();    
    my @pred=();
    my @temp=();
    my $topN=0;
    my $tot_pred=0;
    my $cscore=0.01;


    open(PDB, "<$dir2/$filename");
    while(my $line4=<PDB>)
    {
	if($line4 =~ /(\S+)\t(.+)/)
	{
	    $topN++;
	    $pbs{$topN, 1}=$1;
	    $pbs{$topN, 2}=$2;
	
		$pbs{$topN, 1}=0.99 if($pbs{$topN, 1}>=1);
	}
    }    
    close(PDB);


    #display prediction on html
    my @firstres = split(/\s+/, $pbs{1, 2});
    my $fres     = $pbs{1, 2}; $fres =~ s/\s+/,/g;    

    $div    .="       <tr><td align =\"center\"><script type=\"text/javascript\">jmolInitialize(\"../../jmol/\")\;jmolSetAppletColor(\"#000000\")\;jmolApplet(500, \"load protein.pdb; set frank off; select all; spacefill off; wireframe off; cartoons;  select $fres; wireframe 75; spacefill 100; color blue;";
    
    
    foreach my $r(@firstres)
    {
	$div .= "select $r and \*.ca; label %m%r; color label magenta;";   
    }	

    $div     .="     set spin x 10; set spin y 10; spin off;\");</script><br/><SCRIPT>jmolCheckbox(\"set spin x 10; set spin y 10; spin on\", \"spin off\", \"Spin On/Off\", false)</SCRIPT> </td>\n";
	$div    .="       <td valign=\"top\">";
    $div    .="       <table border=\"0\"  style=\"font-family:Arial;font-size:13px;\"><tr bgcolor=\"#DEDEDE\"><th>Click to view</th><th>Rank</th>  <th>C-score</th>  <th>Predicted binding residues</th>  </tr>\n";   
   
       
    my $d=0;
    for(my $i=1; $i<=$topN; $i++)
    {
	if($i > $MAXP)
	{
	    last;
	}

	my @res=split(/\s+/, $pbs{$i, 2});

	if(@res==0)
	{
	    next;
	}
	
	$d++;


	my $bgcolor="";
	if($d%2==0)
	{
	    #$bgcolor="bgcolor=\"#F0FFF0\"";
	    $bgcolor="bgcolor=\"#DEDEDE\"";
	    #$bgcolor="bgcolor=white";
	}

	my $checked="false";
	my $res1=join(',', @res);


	if($d==1)
	{
	    $results .= "<tr bgcolor=\"#DEDEDE\"><td><b>ConCavity</b></td><td>$d</td><td>N/A</td><td> $res1</td></tr>";
	}
	else
	{
	    $results .= "<tr><td></td><td>$d</td><td>N/A</td><td>$res1 </td></tr>";
	}

	$div .= "       <tr $bgcolor>\n";
	$div .= "       <td align=\"center\"><script language=\"JavaScript\" type=\"text/javascript\">jmolRadio(\"load protein.pdb; set frank off; select all; spacefill off; wireframe off; cartoons; select hetero; spacefill 95\%; set radius 0.90; color cpk; set ambient 40; select $res1; wireframe 75; spacefill 100; color blue;";
		    
	foreach my $r(@res)
	{
	    $div .= "select $r and \*.ca; label %m%r; color label magenta;";
	}

	$div .= "    set spin x 5; set spin y 5; spin off;\", \"\", $checked)\;</script></td>\n";

	$div .= "    <font face=\"Monospace\"><td valign=\"middle\" align=\"center\">$d</td> <td valign=\"middle\" align=\"left\">$pbs{$i, 1}</td> <td valign=\"middle\" align=\"left\">$res1</td></tr>\n";        
    } 

  loopout1:;
    $div    .="       </table>\n";
    $div    .="       <br/>\n";
    $div    .="       <table  cellspacing=\"2\" border=\"0\" style=\"font-family:Arial;font-size:12px;\">\n";


    $div    .= "       </table></td></tr>\n";
  nobs:;
    $div    .= "     </table>\n";
    $div    .= "   </td></tr></table>\n";
    $div    .= "  </div>\n";
    $div    .= "</td></tr>\n";


    $div    .="
     </div>     
</div>
</td></tr>
";

    return($div, $results);


}


sub makeCLRdiv
{
    my($dir1, $model, $dir2, $filename, $sequence, $bin, $www)=@_;      
    my $MAXP= 10;
    my $div ='';    
    my %ts=(
        'ALA'=>'A', 'ARG'=>'R', 'ASN'=>'N', 'ASP'=>'D', 'CYS'=>'C', 'GLN'=>'Q', 'GLU'=>'E', 'GLY'=>'G',
        'HIS'=>'H', 'ILE'=>'I', 'LEU'=>'L', 'LYS'=>'K', 'MET'=>'M', 'PHE'=>'F', 'PRO'=>'P', 'SER'=>'S',
        'THR'=>'T', 'TRP'=>'W', 'TYR'=>'Y', 'VAL'=>'V', 'ASX'=>'N', 'GLX'=>'Q', 'UNK'=>'G',
        'A'=>'ALA', 'R'=>'ARG', 'N'=>'ASN', 'D'=>'ASP', 'C'=>'CYS', 'Q'=>'GLN', 'E'=>'GLU', 'G'=>'GLY',
        'H'=>'HIS', 'I'=>'ILE', 'L'=>'LEU', 'K'=>'LYS', 'M'=>'MET', 'F'=>'PHE', 'P'=>'PRO', 'S'=>'SER',
        'T'=>'THR', 'W'=>'TRP', 'Y'=>'TYR', 'V'=>'VAL', 'B'=>'ASX', 'Z'=>'GLX', 'X'=>'UNK');


    $div ='';
    $div .= "

<tr> <td>
<div id=\"headerDiv\">
     <div id=\"titleText\">COACH Results</div>
      <a id=\"CONHeader\" href=\"javascript:toggle2('CONContent','CONHeader');\" >Hide</a>
</div>
<div style=\"clear:both;\"></div>
<div id=\"contentDiv\">
     <div id=\"CONContent\" style=\"display: block;\">";
   

    $div   .= "   <div style=\"position:relative; background:#F2F2F2;width:100%\">\n";
    $div   .= "       <table border=\"0\" style=\"background:#F2F2F2;align=\"left\" cellpadding=\"10\">\n";



    if(!-s "$dir2/$filename")
    {
        $div    .= "    <td><b>No binding site was predicted by COACH.</b></td></tr>\n";
        goto nobs;
    }

    my $firstbs='';    
    my $conf=0;
    
    my %pbs=();    
    my @pred=();
    
    my @temp=();
    my $topN=0;
    my $tot_pred=0;

    
    open(RESULT,"<$dir2/$filename");
    while(my $line = <RESULT>)
    {
	if($line !~ /^SITE/)
	{	    
	    next;
	}

	chomp($line);

	$topN++;	    
	if($topN > $MAXP)
	{
	    last;
	}
	
	if($line =~/^SITE\s+\d+\t(\S+)\t(\S+)/)
	{
	    my $cscore = $1;
	    my $size   = $2;

	    $pbs{$topN, 0} = $cscore;
	    $pbs{$topN, 1} = $size;

	    $line=<RESULT>;
	    chomp($line);
	    if($line =~ /(\S+)\t(\S+)\t(\S+)\t(.+)\t(\S+)\s+:(\S+)/)
	    {	    
		my $alg1     = $1;
		my $pdb     = $2;
		my $lig     = $3;
		my $xyz     = $4;	
		my $qua     = $5;
		my $pbsr    = $6;

		
		if($alg1 eq "COF")
		{	
		    $pbs{$topN, 3}="CH_CF_$pdb\_$lig";
		    $lig=substr($lig, 5);
		    $pbs{$topN, 2}="$pdb\_$lig";		    
		    $pbs{$topN, 4}="COFACTOR";
		}
		elsif($alg1 eq "TMS")
		{
		    $pbs{$topN, 3}="CH_TM_$pdb\_$lig";
		    $lig=substr($lig, 5);
		    $pbs{$topN, 2}="$pdb\_$lig";		    
		    $pbs{$topN, 4}="TM-SITE";		    
		}
		elsif($alg1 eq "FIN")
		{
		    $pbs{$topN, 2}="$lig";
		    $pbs{$topN, 3}="CH_FN_$lig";
		    $pbs{$topN, 4}="FINDSITE";
		}
		elsif($alg1 eq "SST")
		{
		    $lig=substr($lig, 5);
		    $pbs{$topN, 2}="$pdb\_$lig";
		    $pbs{$topN, 3}="CH_protein";
		    $pbs{$topN, 4}="S-SITE"; #no template ligand structure
		}	
		else
		{
		    $pbs{$topN, 2}="N/A";
		    $pbs{$topN, 3}="CH_protein";
		    $pbs{$topN, 4}="ConCavity"; #no template ligand structure
		}	
		$pbs{$topN, 5}=$xyz;
		$pbs{$topN, 6}=$qua;

		my @pred=split(/,/, $pbsr);
		push @{$pbs{$topN, 8}}, @pred;
	    }

	my $alllig="";
	if($pbs{$topN, 4} ne "ConCavity")
	{
	    $line=<RESULT>;
	    chomp($line);
	    my @lig=split(/,/, $line);
	    
	    for(my $i=0; $i<@lig; $i++)
	    {					
		$alllig .= "$lig[$i],";		
		if($i>=1 && $i<@lig-1)
		{
		    $alllig .= "...";
		    last;
		}
	    }    	  
		$alllig =~ s/UUU/k-mer/mg;
	    $alllig =~ s/,$//;
	}
	    if($alllig eq ""){$alllig="N/A"};
	    $pbs{$topN, 7}=$alllig;
	}
    }
    close(RESULT);

    #display COACH prediction on html


    my @firstres = @{$pbs{1, 8}};
    my $fres     = join(',', @{$pbs{1, 8}});

    my $repTemp=$pbs{1, 3};

	$div    .="       <tr><td valign=\"top\" align =\"center\"><script type=\"text/javascript\">jmolInitialize(\"../../jmol/\")\;jmolSetAppletColor(\"#000000\")\;jmolApplet(500, \"load protein/coach/$repTemp.pdb; set frank off; select all; cpk off; spacefill off; wireframe off; cartoons;  set ambient 40; select $fres; wireframe 75; spacefill 100; color blue;";

    foreach my $r(@firstres)
    {
	$div .= "select $r and \*.ca; label %m%r; color label magenta;";   	
    }	           	    	

    if($repTemp =~ /NUC/)
    {
        $div .= "select hetero; color greenyellow;  cartoons; wireframe off; spacefill off; set ambient 40;";
    }
    else
    {
        #print "$repTemp\n";
        $div .= "select hetero; color greenyellow; set radius 0.90; set frank off; spacefill; wireframe off;";
    }    

    #$div     .= " zoomto {$pbs{1, 5}} 250; ";
    $div     .="     set spin x 10; set spin y 10; spin off;\");</script><br/><SCRIPT> jmolButton(\"Reset\",\"Reset to initial orientation\");  jmolCheckbox(\"set spin x 10; set spin y 10; spin on\", \"spin off\", \"Spin On/Off\", false)</SCRIPT>
</td>\n";



    #table starts from here
    $div    .="       <td valign=\"top\">";

    $div    .="       <table border=\"0\"  style=\"font-family:Arial;font-size:13px;\"><tr bgcolor=\"#DEDEDE\"><th>Click to view</th><th>Rank</th><th>C-score<sup>a</sup></th><th>Cluster<br>size<sup>b</sup></th> <th>Rep<br>Templ<sup>c</sup></th> <th>Rep<br>Lig<sup>d</sup></th> <th>Mult<br>Templ<sup>e</sup></th> <th>Consensus Binding Residues</th> </tr>\n";   
        

    for(my $i=1; $i<=$topN; $i++)
    {
	if($i > $MAXP)
	{
	    last;
	}
	
	my $bgcolor="";
	if($i%2==0)
	{
	    #$bgcolor="bgcolor=\"#F0FFF0\"";
	    $bgcolor="bgcolor=\"#DEDEDE\"";
	    #$bgcolor="bgcolor=white";
	}


	my $checked="false";
	if($i == 1)
	{
	    $checked="true";
	}

	my $cscore= sprintf("%.2f", $pbs{$i, 0});
	my @res=@{$pbs{$i, 8}};
	my $res1=join(',', @res);

	$repTemp=$pbs{$i, 3};
	my $repTemp1=$pbs{$i, 2};

	my $size=$pbs{$i, 1};


	$div .= "       <tr $bgcolor>\n";


	$div .= "       <td align=\"center\"><script language=\"JavaScript\" type=\"text/javascript\">jmolRadio(\"load protein/coach/$repTemp.pdb; set frank off; select all; cpk off; spacefill off; wireframe off; cartoons;  set ambient 40; select $res1; color blue; wireframe 75; spacefill 100;";

		    
	foreach my $r(@res)
	{
	    $div .= "select $r and \*.ca; label %m%r; color label magenta;";
	}
	    	    
	if($repTemp =~ /NUC/)
	{
	    $div .= "select hetero; color greenyellow;  cartoons; wireframe off; spacefill off; set ambient 40;";
	}
	else
	{
	    #print "$repTemp\n";
	    $div .= "select hetero; color greenyellow; set radius 0.90; set frank off; spacefill; wireframe off;";
	}
	
	
	#$div     .= " zoomto {$pbs{$i, 5}} 250; ";
	$div .= "    set spin x 5; set spin y 5; spin off;\", \"\", $checked)\;</script></td>\n";	

	if($pbs{$i, 4} eq "TM-SITE" || $pbs{$i, 4} eq "COFACTOR")
	{
	    my $pdbid=substr($repTemp1, 0, 5);
	    my $lig=substr($repTemp1, 6);

	    my $ligname="$lig";
	    if($ligname eq "III")
	    {
		$ligname = "PEPTIDE";
	    }
	    elsif($ligname eq "NUC")
	    {
		$ligname = "Nuc.Acid";
	    }
                elsif($ligname eq "UUU")
                {
                        $ligname = "k-mer";
                }


	    $div .= "    <font face=\"Monospace\"><td valign=\"middle\" align=\"center\">$i</td><td valign=\"middle\" align=\"center\">$cscore</td> <td valign=\"middle\" align=\"center\">$size</td> <td valign=\"middle\" align=\"left\"><a href=protein/coach/$repTemp.pdb>$pdbid</a></td> <td valign=\"middle\" align=\"left\"><a href=../../../BioLiP/sym.cgi?code=$lig target=\"_blank\">$ligname</a> </td>  <td valign=\"middle\" align=center><a href=protein/coach/CH_complex$i.pdb>Download</a></td>  <td valign=\"middle\" align=\"left\">$res1</td>    </tr>\n";        
	}
	elsif($pbs{$i, 4} eq "S-SITE")
	{
	    my $pdbid=substr($repTemp1, 0, 5);
	    my $pdbid1=substr($repTemp1, 0, 4);
	    my $lig=substr($repTemp1, 6);
	    my $ligname="$lig";
	    if($ligname eq "III")
	    {
		$ligname = "PEPTIDE";
	    }
	    elsif($ligname eq "NUC")
	    {
		$ligname = "Nuc.Acid";
	    }
		elsif($ligname eq "UUU")
		{
			$ligname = "k-mer";
		}	
	    
	    $div .= "    <font face=\"Monospace\"><td valign=\"middle\" align=\"center\">$i</td><td valign=\"middle\" align=\"center\">$cscore</td> <td valign=\"middle\" align=\"center\">$size</td> <td valign=\"middle\" align=\"left\"><a href=../../../BioLiP/qsearch.cgi?pdbid=$pdbid1 target=\"_blank\">$pdbid</a></td>  <td valign=\"middle\" align=\"left\"><a href=../../../BioLiP/sym.cgi?code=$lig target=\"_blank\">$ligname</a></td>      <td valign=\"middle\" align=center>N/A</td>     <td valign=\"middle\" align=\"left\">$res1</td>    </tr>\n";
	}
	elsif($pbs{$i, 4} eq "FINDSITE")
	{
	    my $pdbid=substr($repTemp1, 0, 5);
	    my $pdbid1=substr($repTemp1, 0, 4);
	    my $lig=$repTemp1;
	    $div .= "    <font face=\"Monospace\"><td valign=\"middle\" align=\"center\">$i</td><td valign=\"middle\" align=\"center\">$cscore</td> <td valign=\"middle\" align=\"center\">$size</td> <td valign=\"middle\" align=\"left\"><a href=protein/coach/$repTemp.pdb>$pdbid</a></td> <td valign=\"middle\" align=\"left\"> <a href=http://www.rcsb.org/pdb/explore/explore.do?structureId=$pdbid1 target=\"_blank\">$lig</a> </td>  <td valign=\"middle\" align=center><a href=protein/coach/CH_complex$i.pdb>Download</a></td>    <td valign=\"middle\" align=\"left\">$res1</td>    </tr>\n";    
	}
	else
	{
	    $div .= "    <font face=\"Monospace\"><td valign=\"middle\" align=\"center\">$i</td><td valign=\"middle\" align=\"center\">$cscore</td> <td valign=\"middle\" align=\"center\">$size</td> <td valign=\"middle\" align=\"left\">N/A</td>  <td valign=\"middle\" align=\"left\"> N/A</td>  <td valign=\"middle\" align=\"left\">N/A</td>    <td valign=\"middle\" align=\"left\">$res1</td>    </tr>\n";   	    
	}
    } 

  loopout1:;
    $div    .="       </table>\n";
    $div    .="       <br/>\n";
    $div    .="       <table  cellspacing=\"2\" border=\"0\" style=\"font-family:Arial;font-size:12px;\">\n";

    $div    .= "       <tr><td valign=\"top\"></td><td align=\"justify\">Click <a href=protein/prob.txt target=\"_blank\">here</a> to download the residue-specific binding probability, which is estimated by SVM. </td></tr> \n";

    $div    .= "       <tr><td valign=\"top\"></td><td align=\"justify\">Click <a href=protein/coach/Bsites.inf target=\"_blank\">here</a> to download the predicted bound ligands and detailed prediction summary. </td></tr> \n";

    $div    .= "       <tr><td valign=\"top\"></td><td align=\"justify\">Click <a href=protein/coach/Bsites.clr target=\"_blank\">here</a> to download the templates clustering results. </td></tr> \n";

    $div    .="        <tr><td valign=\"top\">(a)</td><td align=\"justify\"><b>C-score</b> is the confidence score of the prediction. C-score ranges [0-1], where a higher score indicates a more reliable prediction. </td></tr>\n";

    $div    .="        <tr><td valign=\"top\">(b)</td><td align=\"justify\"><b>Cluster size</b> is the total number of templates in a cluster. </td></tr>\n";

    $div    .= "       <tr><td valign=\"top\">(c)</td><td align=\"justify\"><b>Rep Templ</b> presents a predicted representative ligand-protein complex structure from a cluster.</td></tr>\n";

    $div    .= "       <tr><td valign=\"top\">(d)</td><td align=\"justify\"><b>Rep Lig</b> is the bound ligand from the template. Click the ligand name to view its information in <a href=http://zhanglab.ccmb.med.umich.edu/BioLiP/>the BioLiP database</a>.</td></tr>\n";

    $div    .= "       <tr><td valign=\"top\">(e)</td><td align=\"justify\"><b>Mult Templ</b> provides the structures of all ligands in a cluster.</td></tr>\n";

    $div    .="<br>";
    $div    .= "       </table></td></tr>\n";



  nobs:;
    $div    .= "     </table>\n";
    $div    .= "   </td></tr></table>\n";
    $div    .= "  </div>\n";
    $div    .= "</td></tr>\n";

    $div    .="
     </div>     
</div>
</td></tr>
";

    return($div);
}
