#!/usr/bin/perl -w
use strict;


`hostname`=~/(\S+)/;
my $node=$1;
my $datetime=`date`;
my $path=`pwd`;

print "Hostname: $node\n";
print "Started : $datetime\n";
print "Path    : $path\n";






#=pod
my $user      = "zhanglabs";
my $bindir    = "/nfs/amino-home/zhanglabs/IonCom/bin/COACH/bin";                # where the COACH bin is located
my $datadir   = "/nfs/amino-home/zhanglabs/IonCom/output";               # the datadir, where all targets are located
my $target    = "51";                # the name of the target protein, e.g. 13gsA
my $model     = "protein.pdb";                 # the name of the model, e.g., model1.pdb
my $Q         = "urgent";                 # what queue to use
my $run       = "benchmark";                   # real or benchmark
#=cut

=pod
my $user      = "zhanglabs";
my $bindir    = "/home/zhanglabs/COACH/bin";                # where the COACH bin is located
my $datadir   = "/home/zhanglabs/COACH/output";               # the datadir, where all targets are located
my $target    = "CH004950";                # the name of the target protein, e.g. 13gsA
my $model     = "protein.pdb";                 # the name of the model, e.g., model1.pdb
my $Q         = "urgent";                 # what queue to use
my $run       = "real";                   # real or benchmark
=cut



my $modeller= "$bindir/MODELLER";
my $modelname = $model; $modelname=~s/\.pdb//;
my $inputdir  = "$datadir/$target";
my $outputdir = "$inputdir/$modelname";

my $nrep = 0;

 posstart:;
if(!-s "$inputdir/$model")
{
    if(!-s "$inputdir/protein.fasta")
    {
	die "No structure or sequence information is provided!\n";
    }    

    my $length=0;
    my @ttt=`cat $inputdir/protein.fasta`;chomp(@ttt);
    foreach my $t(@ttt)
    {
	next if($t =~ /^>/);
	$t =~ s/\s+//g;
	$length += length $t;
    }

    my $thread_rep=0;
    ##run I-TASSER for structure modelling
    my $tasserdir  = "/nfs/amino-home/zhanglabs/IonCom/bin/COACH/bin/ITASSER";
    my $tasserdata = "$inputdir";
    `mkdir -p $tasserdata`;

  posinit:;

    print "running I-TASSER, step 1...\n";
    #step1
    `$tasserdir/mkinput1.pl $target $Q $datadir $user $tasserdir $run`;


    
    my @inits=qw(
		 SPX
		 FF3
		 HHP
		 MUS
		 
		 JJJb
		 RRR6		 
		 VVV
		 
		 WWW
		 pgen
		 );

    my %namethread=(
		    "MUS" =>"MUSTER",
		    "RRR6"=>"wdPPAS",
		    "WWW" =>"cdPPAS",
		    "SPX" =>"SPARKS-X",
		    "VVV" =>"SP3",
		    "IIIe"=>"HHSEARCH",
		    "HHP" =>"HHSEARCH2",
		    "BBB" =>"PROSPECT2",
		    "RRR3"=>"FFAS03",
		    "PRC" =>"PRC",
		    'IIIj'=>'HHSEARCH I',
		    "JJJb"=>"Neff-PPAS",
		    "FF3"=>"FFAS-3D",
		    "pgen"=>"pGenTHREADER",
		    );   

    my %zscore0=(
		 "MUS"=>6.1,
		 "JJJb"=>8.7,
		 "RRR6"=>9.8,
		 "SPX"=>6.9,
		 "VVV"=>7.0,
		 "WWW"=>6.0,
		 "HHP"=>11.0,
		 "PRC"=>21,
		 "FF3"=>33,
		 "pgen"=>6.3,
		 "BBB"=>3.2,
		 "RRR3"=>18.0,
		 "IIIe"=>10,
		 'IIIj'=>15,
		 );


    while(1)
    {
	my $flag=1;	
	foreach my $init(@inits)
	{
	    my $file_name="$tasserdata/init.$init";
	    if(!-s $file_name)
	    {
		$flag=0;
		last;		
	    }

	    if($init eq "FF3") #fail due to nodes issue sometimes
	    {
		my $numline=`wc -l $file_name`;
		if($numline =~ /(\d+)/)
		{
		    $numline=$1;
		}
		if($numline<10)
		{
		    $flag=0;
			`rm -f $file_name`;
		    last;
		}		
	    }

	}

	if($flag==0)
	{    
	    my $runningjobs=`qstat -f`;
	    if($runningjobs =~ /22_$target/)  #threading is running
	    {
		sleep(60);
	    }
	    else
	    {
		if(-s "$tasserdata/init.MUS")
		{
		    if(!-s "$tasserdata/init.HHP") #fail sometimes
		    {
			`cp $tasserdata/init.MUS $tasserdata/init.HHP`;
		    }
		}
		
		goto posinit;
	    }
	}
	else
	{
	    last;
	}
    }

    
    print "running I-TASSER, step 2...\n";
    #step2
    `$tasserdir/mkinput2.pl $target $datadir`;
    chdir "$tasserdata";
    `$tasserdir/calcinitdat2 seq.txt init.dat seq.dat.ss > align.txt`;

    #run MODELLER
    if(!-d "$tasserdata/tttt")
    {
	`$modeller/buildmodeller.pl $target $datadir $bindir/MODELLER`;
    }

=pod    
    print "running I-TASSER, step 3...\n";
    #step3
    `$tasserdir/submittasser.pl $target $Q`;
    #`/home/yangji/application/MODELLER/buildmodeller.pl $target`;

    print "running I-TASSER, step 4...\n";
    #step4
    if(!-s "$tasserdata/model1.pdb")
    {
	`$tasserdir/cluster.pl $target $Q`;
    }  

    ##check if clustering is done
    my $niter=0;
    while(!-s "$tasserdata/model1.pdb") #at least there should be one model from I-TASSER
    {	
	#die "No model is given by I-TASSER!\n";
	sleep(60);
	$niter++;
	if($niter>1800) #30 hours
	{
	    die "No model is given by I-TASSER!\n";
	}
    }
=cut


    if(!-s "$tasserdata/init.dat")
    {
	exit;
    }
    
    open(IN, "$tasserdata/init.dat");
    my $line=<IN>;
    my $type = "";
    if($line =~ /\s*\S+\s+(\S+)\s+\S+\s+\S+/)
    {
	$type = $1;
    }
       

    while($line = <IN>)
    {
	if($line !~ /ATOM/ && $line !~ /TER/)
	{
	    if($line=~/\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)/)
	    {
		my $Lali   = $1;
		my $zscore = $2;
		my $id     = $3;
		my $pdb    = $4;
		my $prog   = $5;
		my $pid    = substr($pdb, 0, 4);
		my $id1    = $id-1;
		my $tmodel  = "tmodel" . $id1 . ".pdb";
		if(-s "$tasserdata/tttt/$tmodel")
		{
		    if($prog eq "SPX" && $type ne "hard")
		    {			
			next;
		    }

		    if($prog eq "HHP" || $prog eq "IIIe")
		    {
			next if($Lali/$length<0.3);
			
		    }
		    

		    if($type eq "medm")
		    {
			$type = "a medium";
		    }
		    elsif($type eq "easy")
		    {
			$type = "an easy";
		    }
		    else
		    {
			$type = "a hard";
		    }
		    `cp $tasserdata/tttt/$tmodel $inputdir/$model`;
		    open(CS, ">$tasserdata/cscore");
		    print CS "This is $type target for structure modeling. The structure was predicted by $namethread{$prog} with template <a href=\"http://www.rcsb.org/pdb/explore/explore.do?structureId=$pid\" target=\"_blank\">$pdb</a>. z-score=$zscore (cutoff=$zscore0{$prog}).\n";
		    close(CS);
		    last;					
		}
	    }	       
	}	    
    }
    close(IN);
}

my $email=`cat $inputdir/email.txt`;
chomp($email);

my $seq="seq.txt";

if(!-s "$inputdir/$seq")
{
    my $queryseq = &getfasta("$inputdir/$model");
    open(FSEQ, ">$inputdir/$seq");
    print FSEQ ">seq\n";
    print FSEQ "$queryseq\n";
    close(FSEQ);    
}
`mkdir -p $outputdir`;

#you do not need to change below
my $blastdir  ="/nfs/amino-library/blast";   # Directory containing  BLAST executables
my $nrdb      ="/nfs/amino-library/nr/nr";   # Non-redundant sequence database for runing PSI-BLAST


##### temporary working dir ########
my $tag           = "COACH_$target\_$modelname";
my $workdir       = "/tmp/$user/$tag";
`/bin/mkdir -p $workdir`;
`/bin/rm -f $workdir/*`;

chdir "$workdir";
`cp $inputdir/$model .`;
`cp $inputdir/$seq .`;
`cp $bindir/clusteringcoach .`;

my $len=0;
my $queryseq="";
open(SEQ, "$seq");
while(my $line = <SEQ>)
{
    chomp($line);
    if($line=~/>/)
    {
	next;
    }
    else
    {
	$line =~ s/\s+//mg;
	$len += length $line;	
	$queryseq .= $line;
    }
}
close(SEQ);


my $runningjobs=`qstat -f`;
while($runningjobs !~ /zhanglabs/)
{
    $runningjobs=`qstat -f`;
}


################ Submit FINDSITE by qsub 
my $finoutput="$outputdir/findsite";
if(!-e "$finoutput/$modelname.pockets.dat")
{
    `mkdir -p $finoutput`;
    my $fintag   = "FIN_$target\_$modelname"; 
    my $finmod   = "findsitemod";

    if($runningjobs !~ /$fintag/)
    {
	my $mod      =`cat $bindir/$finmod`;
	$mod =~ s/\!S\!/$target/mg;
	$mod =~ s/\!RUN\!/$run/mg;   
	$mod =~ s/\!DATADIR\!/$inputdir/mg;
	$mod =~ s/\!USER\!/$user/mg;
	$mod =~ s/\!MODEL\!/$model/mg;
	$mod =~ s/\!SEQ\!/$seq/mg;
	$mod =~ s/\!BINDIR\!/$bindir/mg;    
	my $walltime="walltime=10:00:00";
	open(FH2,">$finoutput/$fintag.pl");
	print FH2 "$mod";
	close(FH2);
	`chmod a+x $finoutput/$fintag.pl`;
	`qsub -q $Q -e $finoutput/err_$fintag -o $finoutput/out_$fintag -l $walltime -N $fintag $finoutput/$fintag.pl`;    
	print "$fintag is submitted!\n";
    }
    else
    {
	print "$fintag is running. Skip this job\n";
    }
}
else
{
    print "FINDSITE has been done, skip running\n";
}


################run PSI-BLAST once for ConCavity, COFACTOR, and S-SITE
if(!-s "$inputdir/blast.out")
{
    print "running PSI-BLAST...\n";
    system ("$blastdir/bin/blastpgp  -b 1000 -j 3 -h 0.001 -d $nrdb -i $seq > blast.out");
    `/bin/cp blast.out $inputdir/`;
}
else
{
    print "Blast result exists, copy directly...\n";
    `/bin/cp $inputdir/blast.out .`;
}




################ submit COFACTOR by qsub 
my $cofoutput="$outputdir/cofactor";
if(!-e "$cofoutput/Bsites.dat")
{
    `mkdir -p $cofoutput`;
    my $predictbions = "YES"; ### Cu2+,Na+, Mg2+               YES or NO
    my $progname     = "cofactormod";
    my $modeltype    = "native";
    my $tag          = "CF_$target\_$modelname";     	
    my $mod          = `cat $bindir/$progname`; 

    if($runningjobs !~ /$tag/)
    {
	$mod=~s/\!S\!/$target/mg;
	$mod=~s/\!DATADIR\!/$inputdir/mg;
	$mod=~s/\!MODEL\!/$model/mg;
	$mod=~s/\!MODELTYPE\!/$modeltype/mg;
	$mod=~s/\!TAG\!/$tag/mg;  
	$mod=~s/\!USER\!/$user/mg;
	$mod=~s/\!BIONS\!/$predictbions/mg;
	$mod=~s/\!RUN\!/$run/mg;       
	$mod =~ s/\!COACHBIN\!/$bindir/mg;    
	
	if($email =~ /proteinmodelportal/ || $email =~ /yangji/)
	{
	    $mod =~ s/\!MAXTIME\!/30/mg;    
	}
	else
	{
	    $mod =~ s/\!MAXTIME\!/15/mg;    
	}



	my $walltime="walltime=60:00:00";
	open(FH2,">$cofoutput/$tag.pl");
	print FH2 "$mod";
	close(FH2);
	`chmod a+x $cofoutput/$tag.pl`;	 	
	`qsub -q $Q -e $cofoutput/err_$tag -o $cofoutput/out_$tag -l $walltime -N $tag $cofoutput/$tag.pl`;	
	print "$tag was submitted!\n";
    }
    else
    {
	print "$tag is running. Skip this job\n";
    }

}
else
{
    print "COFACTOR has been done, skip running\n";
}


#run ConCavity
#check if it was done before
my $conoutput="$outputdir/concavity";
if(!-e "$conoutput/$modelname.bsr")
{
    `mkdir -p $conoutput`;
    my $contag   = "CON_$target\_$modelname"; 
    my $conmod   = "concavitymod";
    my $version  = "v2";
	
    if(!-s "$bindir/$conmod")
    {
	die "$bindir/$conmod is lost!\n";
    }
    my $mod   = `cat $bindir/$conmod`;
    $mod      =~ s/\!USER\!/$user/mg;
    $mod      =~ s/\!S\!/$seq/mg;
    $mod      =~ s/\!PDBID\!/$target/mg;
    $mod      =~ s/\!MODEL\!/$model/mg;
    $mod      =~ s/\!DATADIR\!/$inputdir/mg;
    $mod      =~ s/\!BINDIR\!/$bindir/mg;
    open(FH2,">$conoutput/$contag.pl");
    print FH2 "$mod";
    close(FH2);
    `chmod a+x $conoutput/$contag.pl`;
    print "running concavity...\n";
    `$conoutput/$contag.pl`;
}
else
{
    print "ConCavity has been done, skip running\n";
}


#check if ConCavity is done
while(!-s "$inputdir/JSD_concavity.dat")
{     
    die "JSD_concavity.dat is given by ConCavity, please check\n";        
}


############## Step 4:  submit TM-SITE ###############
while(!-s "$conoutput/$modelname.bsr")
{     
    die "No result is given by ConCavity, please check\n";        
}

my $tmoutput="$outputdir/tmsite";
if(!-e "$tmoutput/Bsites.dat")
{    
    `mkdir -p $tmoutput`;

    my $tag         = "TM_$target\_$modelname";
    my $prog_name   = "$tag.pl";
    if($runningjobs !~ /$tag/)
    {
	my $mod=`cat $bindir/tmsitemod`;	
	$mod =~ s/\!USER\!/$user/mg;
	$mod =~ s/\!DATADIR\!/$datadir/mg;
	$mod =~ s/\!NAME\!/$target/mg;
	$mod =~ s/\!PDBNAME\!/$model/mg;
	$mod =~ s/\!TAG\!/$tag/mg;
	$mod =~ s/\!RUN\!/$run/mg;
	$mod =~ s/\!BINDIR\!/$bindir/mg;
	
	open(FH2,">$tmoutput/$prog_name");
	print FH2 "$mod";
	close(FH2);
	`chmod a+x $tmoutput/$prog_name`; 
	
	my $walltime="walltime=500:00:00";    	
	`qsub -q $Q -e $tmoutput/err_$tag -o $tmoutput/out_$tag -l $walltime -N $tag $tmoutput/$prog_name`;
	print "$tag was submitted!\n";	
    }
    else
    {
	print "$tag is running. Skip this job\n";
    }
}
else
{
    print "TM-SITE has been done, skip running\n";
}


############## Step 3: submit S-SITE ###############
my $ssoutput = "$inputdir/ssite";
if(!-e "$ssoutput/Bsites_fpt.dat")
{    
    `mkdir -p $ssoutput`;

    my $tag         = "SS_$target";
    my $prog_name   = "$tag.pl";
	
    my $mod=`cat $bindir/ssitemod`;	
    $mod =~ s/\!USER\!/$user/mg;
    $mod =~ s/\!DATADIR\!/$datadir/mg;
    $mod =~ s/\!NAME\!/$target/mg;
    $mod =~ s/\!TAG\!/$tag/mg;
    $mod =~ s/\!RUN\!/$run/mg;
    $mod =~ s/\!BINDIR\!/$bindir/mg;
    $mod =~ s/\!CONDIR\!/$inputdir/mg;
	
    open(FH2,">$ssoutput/$prog_name");
    print FH2 "$mod";
    close(FH2);
    `chmod a+x $ssoutput/$prog_name`; 
	
    my $walltime="walltime=24:00:00";
    ##run TM-SITE locally
    #`qsub -q $Q -e $ssoutput/err_$tag -o $ssoutput/out_$tag -l $walltime -N $tag $ssoutput/$prog_name`;
    #print "$tag was submitted!\n";	
    print "run $prog_name locally\n";	
    `$ssoutput/$prog_name`;    
}
else
{
    print "S-SITE has been done, skip running\n";
}



############## Step 5: make consensus prediction  ###############
##check whether the results from all methods are available
##if some are still running, wait for 2 mins
while(1)
{
    my $alldone=&check_results(); #check if all methods are done
    last if($alldone==1);


    my $runningjobs=`qstat -f`;
    while($runningjobs !~ /zhanglabs/)
    {
	$runningjobs=`qstat -f`;
    }

    if($runningjobs =~ /CF_$target/ || $runningjobs =~ /TM_$target/ || $runningjobs =~ /FIN_$target/)
    {
	sleep(120);
    }
    else
    {
	#something fail due to node issue
	$nrep++;
	if($nrep>2)
	{	    
	    print "Please check problem manually\n";
	    exit;
	}
	else
	{
	    goto posstart;
	}
    }
}




print "making consensus prediction...\n";

`cp $bindir/svm_perf_classify .`;
`cp $bindir/svm_model .`;

`cp $bindir/svm-predict .`;
`cp $bindir/libsvm_model .`;
my ($nuc, $np_ref)=&coach(); #generate per-residue probability with svm 
print "nuc=$nuc\n";
if($nuc ==2 )
{
    #is NUC
    my %nucP=%$np_ref;
    &coach_cat(\%nucP);      
}


#exit;

###clustering
my $mod=`cat $bindir/clustermod`;	
$mod =~ s/\!DATADIR\!/$datadir/mg;
$mod =~ s/\!MODEL\!/$model/mg;
$mod =~ s/\!BINDIR\!/$bindir/mg;
$mod =~ s/\!USER\!/$user/mg;
$mod =~ s/\!TARGET\!/$target/mg;
	
open(FH2,">$inputdir/cluster_CH.pl");
print FH2 "$mod";
close(FH2);
`chmod a+x $inputdir/cluster_CH.pl`; 
`$inputdir/cluster_CH.pl`;



##output
$mod=`cat $bindir/OUTPUTmod_3`;	
$mod =~ s/\!DATADIR\!/$inputdir/mg;
$mod =~ s/\!MODEL\!/$model/mg;
$mod =~ s/\!S\!/$target/mg;
	
open(FH2,">$inputdir/mkoutput.pl");
print FH2 "$mod";
close(FH2);
`chmod a+x $inputdir/mkoutput.pl`; 


#exit;

if($email !~ /proteinmodelportal/) #check prediction by hand before sending results
{
#    `$inputdir/mkoutput.pl`;
}
else
{
#    `$inputdir/mkoutput.pl`;
}




#delete big files
chdir "$inputdir";

if(-s "Temlate_protein.score")
{
    `tar -jcvf Temlate_protein.score.tar.bz2 Temlate_protein.score`;
    `rm -f Temlate_protein.score`;
}
if(-s "PDBsearch_protein.dat")
{
    `tar -jcvf PDBsearch_protein.dat.tar.bz2 PDBsearch_protein.dat`;
    `rm -f PDBsearch_protein.dat`;
}
`rm -fr tttt blast.out err_* out_* protein.out $target* str.txt node* *_$target* simulationjob* *.dd out* closc* comb* dist* rep* tra* yzhang.py exp.dat pair* REF_* *turn* init.SPX init.FF3 init.MUS init.HHP init.VVV init.WWW init.pgen init.BBB init.PRC init.RRR3 init.RRR6 init.JJJb init.IIIj init.IIIe psitmp.chk par.dat`;


#~~~~~~~~~~~~~~~~~~~~~~~ End procedure  ~~~~~~~~~~~~~~~~~~~~~~~~~#
print "Ending...\n";
my $time=`date`;
printf "ending time: $time";
`sync`;
`sync`;
sleep(1);


`rm -fr $workdir`;
print "Done!\n";



sub getfasta
{
    my ($pdb)=@_;
    my $seq="";    
    my %AA=(
	    'ALA'=>'A', 'ARG'=>'R', 'ASN'=>'N', 'ASP'=>'D', 'CYS'=>'C', 'GLN'=>'Q', 'GLU'=>'E', 'GLY'=>'G',
	    'HIS'=>'H', 'ILE'=>'I', 'LEU'=>'L', 'LYS'=>'K', 'MET'=>'M', 'PHE'=>'F', 'PRO'=>'P', 'SER'=>'S',
	    'THR'=>'T', 'TRP'=>'W', 'TYR'=>'Y', 'VAL'=>'V', 'ASX'=>'N', 'GLX'=>'Q', 'UNK'=>'G',
	    'A'=>'ALA', 'R'=>'ARG', 'N'=>'ASN', 'D'=>'ASP', 'C'=>'CYS', 'Q'=>'GLN', 'E'=>'GLU', 'G'=>'GLY',
	    'H'=>'HIS', 'I'=>'ILE', 'L'=>'LEU', 'K'=>'LYS', 'M'=>'MET', 'F'=>'PHE', 'P'=>'PRO', 'S'=>'SER',
	    'T'=>'THR', 'W'=>'TRP', 'Y'=>'TYR', 'V'=>'VAL', 'B'=>'ASX', 'Z'=>'GLX', 'X'=>'UNK');
    

    open(FPDB, $pdb) or die "$pdb is missed!\n";
    my %resatoms=();
    while(my $line = <FPDB>)
    {
	if($line =~ /^ATOM/i)
	{
            my $res_name  = substr($line, 17, 3);  
            my $res_no    = substr($line, 22, 5);
            my $check     = $res_no .  substr($line, 12, 4); #atom

	    if(!exists $resatoms{$check}) ##check for alternative position atoms
	    {
		$resatoms{$check}=1;

		my $atom_name=substr($line, 12, 4);
		if($atom_name eq ' CA ' || $atom_name eq '  CA' || $atom_name eq 'CA  ')		
		{
		    $seq = $seq . $AA{$res_name};
		}		
	    }
	}
    }
    close(FPDB);
    return $seq;
}




sub check_results
{

    my $alldone=1;
    #check if FINDSITE is finished
    if(!-e "$finoutput/$modelname.pockets.dat" && ! -e "$finoutput/err_FIN_$target\_$modelname")
    {
	#print "FINDSITE is still running\n";
	$alldone=0;
    }
    
    #check if COFACTOR is finished
    if(!-e "$cofoutput/Bsites.dat")
    {
	#print "COFACTOR is still running\n";
	$alldone=0;
    }
    
    #check if ConCavity is finished
    if(!-e "$conoutput/$modelname.bsr")
    {
	#print "ConCavity is still running\n";
	$alldone=0;
    }
    
    #check if TMSITE is finished
    if(!-e "$tmoutput/Bsites.dat")
    {
	#print "TM-SITE is still running\n";
	$alldone=0;
    }
    
    #check if SSITE is finished
    if(!-e "$ssoutput/Bsites_fpt.dat")
    {
	#print "S-SITE is still running\n";
	$alldone=0;
    }
    
    return $alldone;   
}




sub coach
{
    my %feature=();
    my $topN=3;

    my $nuc=0;
    my %nucP=();
    my @cscores=();
    my %cscore=();
    my ($nucflag, $f_ref) = &COFpred($target, $len, $topN, \%cscore);
    my %f=%$f_ref;
    $nuc+=$nucflag;

    for(my $i=1; $i<=$topN; $i++)
    {
	if(exists $cscore{$i})
	{
	    push(@cscores, $cscore{$i});
	}
	else
	{
	    push(@cscores, 0.0);
	}
    }
    
    my $st=0;       
    my @keys = keys %f;
    if(@keys != $len)
    {
	print "no prediction for COFACTOR\n";

	for(my $i=1; $i<=$len; $i++)
	{
	    my $n=$st;
	    for(my $j=0; $j<$topN; $j++)
	    {
		$feature{$i, $n}=0;
		$n++;
	    }
	}
    }
    else
    {	
	for(my $i=1; $i<=$len; $i++)
	{
	    #print "$i\t";
	    my @p=@{$f{$i}};
	    my $n=$st;
	    for(my $j=0; $j<@p; $j++)
	    {
		$feature{$i, $n}=$p[$j];
		#print "$p[$j]\t";
		$n++;
	    }
	    #print "\n";
	    for(my $j=@p; $j<$topN; $j++)
	    {
		$feature{$i, $n}=0;
		$n++;
	    }
	}
    }
    $st += $topN;



    ############ TMSITE ############
    $topN=2;
    %cscore=();
    ($nucflag, $f_ref)=&TMpred($target, $len, $topN, \%cscore);
    $nuc+=$nucflag;
    %f=%$f_ref;
        
    for(my $i=1; $i<=$topN; $i++)
    {
	if(exists $cscore{$i})
	{
	    push(@cscores, $cscore{$i});
	}
	else
	{
	    push(@cscores, 0.0);
	}
    }


    @keys = keys %f;
    if(@keys != $len)
    {
	print "no prediction for TMSITE\n";

	for(my $i=1; $i<=$len; $i++)
	{
	    my $n=$st;
	    for(my $j=0; $j<$topN; $j++)
	    {
		$feature{$i, $n}=0;
		$n++;
	    }
	}
    }
    else
    {	
	for(my $i=1; $i<=$len; $i++)
	{
	    #print "$i\t";
	    my @p=@{$f{$i}};
	    my $n=$st;
	    for(my $j=0; $j<@p; $j++)
	    {
		$feature{$i, $n}=$p[$j];
		#print "$p[$j]\t";
		$n++;
	    }
	    #print "\n";
	    for(my $j=@p; $j<$topN; $j++)
	    {
		$feature{$i, $n}=0;
		$n++;
	    }
	}
    }
    $st += $topN;  





    ############ SSITE ############
    $topN=1;
    %cscore=();
    $f_ref=&SSpred($target, $len, $topN, \%cscore);
    %f=%$f_ref;
        
    for(my $i=1; $i<=$topN; $i++)
    {
	if(exists $cscore{$i})
	{
	    push(@cscores, $cscore{$i});
	}
	else
	{
	    push(@cscores, 0.0);
	}
    }

    @keys = keys %f;
    if(@keys != $len)
    {
	print "no prediction for SSITE\n";

	for(my $i=1; $i<=$len; $i++)
	{
	    my $n=$st;
	    for(my $j=0; $j<$topN; $j++)
	    {
		$feature{$i, $n}=0;
		$n++;
	    }
	}
    }
    else
    {	
	for(my $i=1; $i<=$len; $i++)
	{
	    #print "$i\t";
	    my @p=@{$f{$i}};
	    my $n=$st;
	    for(my $j=0; $j<@p; $j++)
	    {
		$feature{$i, $n}=$p[$j];
		#print "$p[$j]\t";
		$n++;
	    }
	    #print "\n";
	    for(my $j=@p; $j<$topN; $j++)
	    {
		$feature{$i, $n}=0;
		$n++;
	    }
	}
    }
    $st += $topN;  





    ############ FINDSITE ############
    $topN=1;    
    %cscore=();
    $f_ref=&FINpred($target, $len, $topN, \%cscore);
    %f=%$f_ref;
        
    for(my $i=1; $i<=$topN; $i++)
    {
	if(exists $cscore{$i})
	{
	    push(@cscores, $cscore{$i});
	}
	else
	{
	    push(@cscores, 0.0);
	}
    }

    @keys = keys %f;
    if(@keys != $len)
    {
	print "no prediction for FINDSITE\n";

	for(my $i=1; $i<=$len; $i++)
	{
	    my $n=$st;
	    for(my $j=0; $j<$topN; $j++)
	    {
		$feature{$i, $n}=0;
		$n++;
	    }
	}
    }
    else
    {	
	for(my $i=1; $i<=$len; $i++)
	{
	    #print "$i\t";
	    my @p=@{$f{$i}};
	    my $n=$st;
	    for(my $j=0; $j<@p; $j++)
	    {
		$feature{$i, $n}=$p[$j];
		#print "$p[$j]\t";
		$n++;
	    }
	    #print "\n";
	    for(my $j=@p; $j<$topN; $j++)
	    {
		$feature{$i, $n}=0;
		$n++;
	    }
	}
    }
    $st += $topN; 



    ############ ConCavity ############
    $topN=1;
    $f_ref=&CONpred($target);
    %f=%$f_ref;    
        
    @keys = keys %f;
    if(@keys != $len)
    {
	print "no prediction for ConCavity\n";

	for(my $i=1; $i<=$len; $i++)
	{
	    my $n=$st;
	    for(my $j=0; $j<$topN; $j++)
	    {
		$feature{$i, $n}=0;
		$n++;
	    }
	}
    }
    else
    {	
	for(my $i=1; $i<=$len; $i++)
	{
	    #print "$i\t$f{$i}\n";
	    my $n=$st;
	    $feature{$i, $n}=$f{$i};
	    $n++;	
	}	 
    }
    $st += $topN;  







    open(TR, ">features.dat");
    for(my $i=1; $i<=$len; $i++)
    {
	print TR "-1 ";
	for(my $j=0; $j<$st; $j++)
	{
	    printf TR "%d:%.3f ", $j+1, $feature{$i, $j};
	}	
	print TR "\n";				
    }
    close(TR);

    `cp features.dat $outputdir/`;


    my @weight=();
    my $totw=0;
    open(SVM, "svm_model");
    while(my $line = <SVM>)
    {	
	chomp($line);
	if($line=~/:/)
	{
	    my @a=split(/:/, $line);
	    for(my $i=1; $i<$#a; $i++)
	    {
		if($a[$i] =~ /(\S+)\s+/)
		{
		    push(@weight, $1);
		    $totw += $1;
		}		
	    }
	}
    }
    close(SVM);
    my $confidence=0;
    if(@weight != @cscores)
    {
	die "wrong SVM model\n";
    }
    else
    {
	for(my $i=0; $i<@weight; $i++)
	{
	    $confidence += $weight[$i]*$cscores[$i];
	}
    }
    $confidence = $confidence/$totw;
    $confidence=1 if($confidence>1);


    #make prediction using SVM
    `./svm_perf_classify features.dat svm_model $modelname.pred`;

    my %prob=();
    open(IN1, "$modelname.pred") or die "svm fail\n";
    for(my $i=1; $i<=$len; $i++)
    {
	my $p=<IN1>;
	chomp($p);
	$prob{$i}=$p;
    }
    close(IN1);
    
    #get probability prediction with libsvm
    `./svm-predict -b 1 features.dat libsvm_model protein_prob.dat`;
    `cp protein_prob.dat $outputdir/`;

    my $maxprob=0;
    my %psvm=();
    my @lbprob=();
    my $nr=0;
    open(PB, "protein_prob.dat");
    <PB>;
    while(my $line=<PB>)
    {
	chomp($line);
	if($line=~/\S+\s+\S+\s+(\S+)/)
	{
	    my $p=$1;
	    $p=sprintf("%.3f", $p);
	    push(@lbprob, $p);

	    $maxprob=$p if($p>$maxprob);
	    $nr++;
	    $psvm{$nr}=$p;
	}
    }
    close(PB);


    my $cameocut=0.51;
    if($maxprob<=$cameocut) ##CAMEO will not accept such prediction
    {
	my $cut=int(0.05 * $nr);
	$cut=1 if($cut<1);
	$cut=5 if($cut>5);
	
	my $inc=0.36;
	if(($cameocut-$maxprob)>$inc)
	{
	    $inc=$cameocut-$maxprob;
	}
	
	##upgrade the top prob
	my @keys=sort {$psvm{$b} <=> $psvm{$a}} keys %psvm;
	$psvm{$keys[0]} += $inc;
	$psvm{$keys[0]} = 1 if($psvm{$keys[0]}>1);
	for(my $i=1; $i<$cut; $i++)
	{
	    if($psvm{$keys[$i]}>=0.15)
	    {
		$psvm{$keys[$i]} += $inc;
		$psvm{$keys[$i]} = 1 if($psvm{$keys[$i]}>1);
	    }
	}	
    }


    my %AA=(
	    'ALA'=>'A', 'ARG'=>'R', 'ASN'=>'N', 'ASP'=>'D', 'CYS'=>'C', 'GLN'=>'Q', 'GLU'=>'E', 'GLY'=>'G',
	    'HIS'=>'H', 'ILE'=>'I', 'LEU'=>'L', 'LYS'=>'K', 'MET'=>'M', 'PHE'=>'F', 'PRO'=>'P', 'SER'=>'S',
	    'THR'=>'T', 'TRP'=>'W', 'TYR'=>'Y', 'VAL'=>'V', 'ASX'=>'N', 'GLX'=>'Q', 'UNK'=>'G',
	    'A'=>'ALA', 'R'=>'ARG', 'N'=>'ASN', 'D'=>'ASP', 'C'=>'CYS', 'Q'=>'GLN', 'E'=>'GLU', 'G'=>'GLY',
	    'H'=>'HIS', 'I'=>'ILE', 'L'=>'LEU', 'K'=>'LYS', 'M'=>'MET', 'F'=>'PHE', 'P'=>'PRO', 'S'=>'SER',
	    'T'=>'THR', 'W'=>'TRP', 'Y'=>'TYR', 'V'=>'VAL', 'B'=>'ASX', 'Z'=>'GLX', 'X'=>'UNK');

    if(@lbprob != $len)
    {
	die "length is not equal\n";
    }

  
    
    my ($metalflag, $metalprob_ref)=&metal_cof();    
    my %metalprob= %$metalprob_ref;
 
    my %nuc=();

    open(CAMEO, ">pred-1.txt");
    open(PROB, ">prob.txt");

    for(my $i=0; $i<@lbprob; $i++)
    {
	my $aa=$AA{substr($queryseq, $i, 1)};
	my $n=$i+1;
	#my $p=$lbprob[$i];
	my $p=$psvm{$n};
	$p=1.0 if($p>1.0);

	my $pm=0.0;
	if($metalflag==1)
	{
	    if(exists $metalprob{$n})
	    {
		$pm=$metalprob{$n};
	    }
	}
	else
	{
	    $pm=$p;
	}

	$nucP{$n} = $p;
	
	printf CAMEO "r=$aa;n=$n;c=A;|I=%.3f;O=%.3f;P=%.3f;N=%.3f;|\n", $pm, $p, $p, $p;
	if($metalflag==1)
	{
	    printf PROB "r=$aa;n=$n :prob_ions=%.3f;prob_organic=%.3f\n", $pm, $p;
	}
	else
	{
	    printf PROB "r=$aa;n=$n :prob=%.3f\n", $p;
	}
    }
    close(CAMEO);
    close(PROB);
    `cp pred-1.txt $outputdir/`;
    `cp prob.txt $outputdir/`;
    
    my $z_cut=1.0;
    my %zscore=(); 
    my @pred=();
    &z_scores(\%prob, \%zscore);
    for(my $i=1; $i<=$len; $i++)
    {
	if($zscore{$i}>$z_cut)
	{
	    push(@pred, $i);
	}
    }
    
    if(@pred==0)
    {
	print "not enough, use top 3\n ";
	my @keys=sort {$zscore{$b} <=> $zscore{$a}} keys %zscore;
	for(my $i=0; $i<3; $i++)
	{
	    push(@pred, $keys[$i]);
	}
    }

    my  @pred1 = sort {$a <=> $b} @pred;
    open(OUT, ">$modelname.pred");
    print OUT "#COF1\tCOF2\tCOF3\tTMS1\tTMS2\tSSI1\tFIN1\tCOACH\n";
    foreach my $c(@cscores)
    {
	printf OUT "%.2f\t", $c;	
    }
    printf OUT "%.2f\n", $confidence;

    print OUT "#BSR\tSVM\tZscore\n";
    foreach my $p(@pred1)
    {
	printf OUT "%-4d\t%.3f\t%.3f\n", $p, $prob{$p}, $zscore{$p};
    }
    close(OUT);

    `cp $modelname.pred $outputdir/`; 

    print "clustering... \n";
    &clustering();

    return ($nuc, \%nucP);
}





## In case NUC has been predicted, 
## we have to re-calculate for organic ligands by removing NUC
#################COACH category##################
sub coach_cat
{
    my ($nuc_ref)=@_;
    my %nucP=%$nuc_ref;

    my %feature=();
    my $topN=3;

    my @cscores=();
    my %cscore=();
    my $f_ref = &COFpred_cat($target, $len, $topN, \%cscore);
    my %f=%$f_ref;

    for(my $i=1; $i<=$topN; $i++)
    {
	if(exists $cscore{$i})
	{
	    push(@cscores, $cscore{$i});
	}
	else
	{
	    push(@cscores, 0.0);
	}
    }
    
    my $st=0;       
    my @keys = keys %f;
    if(@keys != $len)
    {
	print "no prediction for COFACTOR\n";

	for(my $i=1; $i<=$len; $i++)
	{
	    my $n=$st;
	    for(my $j=0; $j<$topN; $j++)
	    {
		$feature{$i, $n}=0;
		$n++;
	    }
	}
    }
    else
    {	
	for(my $i=1; $i<=$len; $i++)
	{
	    #print "$i\t";
	    my @p=@{$f{$i}};
	    my $n=$st;
	    for(my $j=0; $j<@p; $j++)
	    {
		$feature{$i, $n}=$p[$j];
		#print "$p[$j]\t";
		$n++;
	    }
	    #print "\n";
	    for(my $j=@p; $j<$topN; $j++)
	    {
		$feature{$i, $n}=0;
		$n++;
	    }
	}
    }
    $st += $topN;



    ############ TMSITE ############
    $topN=2;
    %cscore=();
    $f_ref=&TMpred_cat($target, $len, $topN, \%cscore);
    %f=%$f_ref;
        
    for(my $i=1; $i<=$topN; $i++)
    {
	if(exists $cscore{$i})
	{
	    push(@cscores, $cscore{$i});
	}
	else
	{
	    push(@cscores, 0.0);
	}
    }


    @keys = keys %f;
    if(@keys != $len)
    {
	print "no prediction for TMSITE\n";

	for(my $i=1; $i<=$len; $i++)
	{
	    my $n=$st;
	    for(my $j=0; $j<$topN; $j++)
	    {
		$feature{$i, $n}=0;
		$n++;
	    }
	}
    }
    else
    {	
	for(my $i=1; $i<=$len; $i++)
	{
	    #print "$i\t";
	    my @p=@{$f{$i}};
	    my $n=$st;
	    for(my $j=0; $j<@p; $j++)
	    {
		$feature{$i, $n}=$p[$j];
		#print "$p[$j]\t";
		$n++;
	    }
	    #print "\n";
	    for(my $j=@p; $j<$topN; $j++)
	    {
		$feature{$i, $n}=0;
		$n++;
	    }
	}
    }
    $st += $topN;  





    ############ SSITE ############
    $topN=1;
    %cscore=();
    $f_ref=&SSpred($target, $len, $topN, \%cscore);
    %f=%$f_ref;
        
    for(my $i=1; $i<=$topN; $i++)
    {
	if(exists $cscore{$i})
	{
	    push(@cscores, $cscore{$i});
	}
	else
	{
	    push(@cscores, 0.0);
	}
    }

    @keys = keys %f;
    if(@keys != $len)
    {
	print "no prediction for SSITE\n";

	for(my $i=1; $i<=$len; $i++)
	{
	    my $n=$st;
	    for(my $j=0; $j<$topN; $j++)
	    {
		$feature{$i, $n}=0;
		$n++;
	    }
	}
    }
    else
    {	
	for(my $i=1; $i<=$len; $i++)
	{
	    #print "$i\t";
	    my @p=@{$f{$i}};
	    my $n=$st;
	    for(my $j=0; $j<@p; $j++)
	    {
		$feature{$i, $n}=$p[$j];
		#print "$p[$j]\t";
		$n++;
	    }
	    #print "\n";
	    for(my $j=@p; $j<$topN; $j++)
	    {
		$feature{$i, $n}=0;
		$n++;
	    }
	}
    }
    $st += $topN;  





    ############ FINDSITE ############
    $topN=1;    
    %cscore=();
    $f_ref=&FINpred($target, $len, $topN, \%cscore);
    %f=%$f_ref;
        
    for(my $i=1; $i<=$topN; $i++)
    {
	if(exists $cscore{$i})
	{
	    push(@cscores, $cscore{$i});
	}
	else
	{
	    push(@cscores, 0.0);
	}
    }

    @keys = keys %f;
    if(@keys != $len)
    {
	print "no prediction for FINDSITE\n";

	for(my $i=1; $i<=$len; $i++)
	{
	    my $n=$st;
	    for(my $j=0; $j<$topN; $j++)
	    {
		$feature{$i, $n}=0;
		$n++;
	    }
	}
    }
    else
    {	
	for(my $i=1; $i<=$len; $i++)
	{
	    #print "$i\t";
	    my @p=@{$f{$i}};
	    my $n=$st;
	    for(my $j=0; $j<@p; $j++)
	    {
		$feature{$i, $n}=$p[$j];
		#print "$p[$j]\t";
		$n++;
	    }
	    #print "\n";
	    for(my $j=@p; $j<$topN; $j++)
	    {
		$feature{$i, $n}=0;
		$n++;
	    }
	}
    }
    $st += $topN; 



    ############ ConCavity ############
    $topN=1;
    $f_ref=&CONpred($target);
    %f=%$f_ref;    
        
    @keys = keys %f;
    if(@keys != $len)
    {
	print "no prediction for ConCavity\n";

	for(my $i=1; $i<=$len; $i++)
	{
	    my $n=$st;
	    for(my $j=0; $j<$topN; $j++)
	    {
		$feature{$i, $n}=0;
		$n++;
	    }
	}
    }
    else
    {	
	for(my $i=1; $i<=$len; $i++)
	{
	    #print "$i\t$f{$i}\n";
	    my $n=$st;
	    $feature{$i, $n}=$f{$i};
	    $n++;	
	}	 
    }
    $st += $topN;  







    open(TR, ">features.dat");
    for(my $i=1; $i<=$len; $i++)
    {
	print TR "-1 ";
	for(my $j=0; $j<$st; $j++)
	{
	    printf TR "%d:%.3f ", $j+1, $feature{$i, $j};
	}	
	print TR "\n";				
    }
    close(TR);

    `cp features.dat $outputdir/`;


    my @weight=();
    my $totw=0;
    open(SVM, "svm_model");
    while(my $line = <SVM>)
    {	
	chomp($line);
	if($line=~/:/)
	{
	    my @a=split(/:/, $line);
	    for(my $i=1; $i<$#a; $i++)
	    {
		if($a[$i] =~ /(\S+)\s+/)
		{
		    push(@weight, $1);
		    $totw += $1;
		}		
	    }
	}
    }
    close(SVM);
    my $confidence=0;
    if(@weight != @cscores)
    {
	die "wrong SVM model\n";
    }
    else
    {
	for(my $i=0; $i<@weight; $i++)
	{
	    $confidence += $weight[$i]*$cscores[$i];
	}
    }
    $confidence = $confidence/$totw;
    $confidence=1 if($confidence>1);


    #make prediction using SVM
    `./svm_perf_classify features.dat svm_model $modelname.pred`;

    my %prob=();
    open(IN1, "$modelname.pred") or die "svm fail\n";
    for(my $i=1; $i<=$len; $i++)
    {
	my $p=<IN1>;
	chomp($p);
	$prob{$i}=$p;
    }
    close(IN1);
    
    #get probability prediction with libsvm
    `./svm-predict -b 1 features.dat libsvm_model protein_prob.dat`;
    `cp protein_prob.dat $outputdir/protein_prob_O.dat`;

    my $maxprob=0;
    my %psvm=();
    my @lbprob=();
    my $nr=0;
    open(PB, "protein_prob.dat");
    <PB>;
    while(my $line=<PB>)
    {
	chomp($line);
	if($line=~/\S+\s+\S+\s+(\S+)/)
	{
	    my $p=$1;
	    $p=sprintf("%.3f", $p);
	    push(@lbprob, $p);

	    $maxprob=$p if($p>$maxprob);
	    $nr++;
	    $psvm{$nr}=$p;
	}
    }
    close(PB);


    my $cameocut=0.51;
    if($maxprob<=$cameocut) ##CAMEO will not accept such prediction
    {
	my $cut=int(0.05 * $nr);
	$cut=1 if($cut<1);
	$cut=5 if($cut>5);
	
	my $inc=0.36;
	if(($cameocut-$maxprob)>$inc)
	{
	    $inc=$cameocut-$maxprob;
	}
	
	##upgrade the top prob
	my @keys=sort {$psvm{$b} <=> $psvm{$a}} keys %psvm;
	$psvm{$keys[0]} += $inc;
	$psvm{$keys[0]} = 1 if($psvm{$keys[0]}>1);
	for(my $i=1; $i<$cut; $i++)
	{
	    if($psvm{$keys[$i]}>=0.15)
	    {
		$psvm{$keys[$i]} += $inc;
		$psvm{$keys[$i]} = 1 if($psvm{$keys[$i]}>1);
	    }
	}	
    }


    my %AA=(
	    'ALA'=>'A', 'ARG'=>'R', 'ASN'=>'N', 'ASP'=>'D', 'CYS'=>'C', 'GLN'=>'Q', 'GLU'=>'E', 'GLY'=>'G',
	    'HIS'=>'H', 'ILE'=>'I', 'LEU'=>'L', 'LYS'=>'K', 'MET'=>'M', 'PHE'=>'F', 'PRO'=>'P', 'SER'=>'S',
	    'THR'=>'T', 'TRP'=>'W', 'TYR'=>'Y', 'VAL'=>'V', 'ASX'=>'N', 'GLX'=>'Q', 'UNK'=>'G',
	    'A'=>'ALA', 'R'=>'ARG', 'N'=>'ASN', 'D'=>'ASP', 'C'=>'CYS', 'Q'=>'GLN', 'E'=>'GLU', 'G'=>'GLY',
	    'H'=>'HIS', 'I'=>'ILE', 'L'=>'LEU', 'K'=>'LYS', 'M'=>'MET', 'F'=>'PHE', 'P'=>'PRO', 'S'=>'SER',
	    'T'=>'THR', 'W'=>'TRP', 'Y'=>'TYR', 'V'=>'VAL', 'B'=>'ASX', 'Z'=>'GLX', 'X'=>'UNK');

    if(@lbprob != $len)
    {
	die "length is not equal\n";
    }

  
    
    my ($metalflag, $metalprob_ref)=&metal_cof();    
    my %metalprob= %$metalprob_ref;
 
    open(CAMEO, ">pred-1.txt");
    open(PROB, ">prob.txt");

    for(my $i=0; $i<@lbprob; $i++)
    {
	my $aa=$AA{substr($queryseq, $i, 1)};
	my $n=$i+1;
	#my $p=$lbprob[$i];
	my $p=$psvm{$n};
	$p=1.0 if($p>1.0);

	my $pm=0.0;
	if($metalflag==1)
	{
	    if(exists $metalprob{$n})
	    {
		$pm=$metalprob{$n};
	    }
	}
	else
	{
	    $pm=$p;
	}	
	
	my $pn=$nucP{$n};
	printf CAMEO "r=$aa;n=$n;c=A;|I=%.3f;O=%.3f;P=%.3f;N=%.3f;|\n", $pm, $p, $p, $pn;
	if($metalflag==1)
	{
	    printf PROB "r=$aa;n=$n :prob_ions=%.3f;prob_organic=%.3f;prob_nucleic=%.3f\n", $pm, $p, $pn;
	}
	else
	{
	    printf PROB "r=$aa;n=$n :prob_organic=%.3f;prob_nucleic=%.3f\n", $p, $pn;
	}
    }
    close(CAMEO);
    close(PROB);
    `cp pred-1.txt $outputdir/`;
    `cp prob.txt $outputdir/`;
}



































sub clustering
{
    open(IN, "$modelname.pred");
    <IN>; <IN>; <IN>;
    my %pred=();
    while(my $line = <IN>)
    {
	if($line =~ /(\S+)\s*\t/)
	{
	   $pred{$1}=1;
	}
    }
    close(IN);

    my %xyz=();
    my @bsr=();
    open(IN, "$model");
    while(my $line = <IN>)
    {
	if($line=~/^ATOM/)
	{
	    my $atom_name=substr($line, 12, 4);
            if($atom_name eq ' CA ' || $atom_name eq '  CA' || $atom_name eq 'CA  ')
	    {
		my $res_no= substr($line, 22, 5); $res_no =~ s/\s+//g;
		if(exists $pred{$res_no})
		{		    
		    push(@bsr, $res_no);
		    $xyz{$res_no, 1} = substr($line,30,8);
		    $xyz{$res_no, 2} = substr($line,38,8);
		    $xyz{$res_no, 3} = substr($line,46,8);		    
		}
	    }
	}
    }
    close(IN);
   

    my %dA=();
    open(OUT, ">dist.dat");
    for(my $i=0; $i<@bsr; $i++)
    {   
	my $res1=$bsr[$i];
	#print "$res1\n";
	for(my $j=0; $j<@bsr; $j++)
	{
	    my $res2=$bsr[$j];
	    if($i==$j)
	    { 
		$dA{$i, $j}=0;
	    }
	    elsif($i<$j)
	    {		
		$dA{$i, $j} = &dist($xyz{$res1, 1}, $xyz{$res1, 2}, $xyz{$res1, 3}, $xyz{$res2, 1}, $xyz{$res2, 2}, $xyz{$res2, 3});		
	    }
	    else
	    {
		$dA{$i, $j} = $dA{$j, $i};
	    }
	    printf OUT "%5.2f ", $dA{$i, $j};
	}
	print OUT "\n";
    }
    close(OUT);

    my $len=@bsr;
    my @rst = `./clusteringcoach dist.dat $len 8`;

    my $m=0;
    my $siten=0;
    open(OUT, ">coach_cluster.dat");
    foreach my $r(@rst)
    {
	if($r =~ /cluster \d+:(\S+),/)
	{	    	
	    $siten++;
	    my @a=split(/,/, $1);
	    if(@a>=2)
	    {
		$m++;
		print OUT "Site $m\n";
		my @c=();
		foreach my $b(@a)
		{
		    my $i=$b-1;
		    push(@c, $bsr[$i]);
		}    

		my @c1=sort {$a<=>$b} @c;
		print OUT join(",", @c1) . "\n";

		#find ligand for this site from COFACTOR and TM-SITE
		
		my %all=();
		my %seqid=();
		my @ids="";
		my @cof=`cat $cofoutput/Bsites.dat`;
		for(my $i=0; $i<@cof; $i++)
		{
		    if($i>=5)
		    {
			last;
		    }
		    my $line=$cof[$i];
		    if($line =~ /(.+):(\S+)/)
		    {
			my $inf=$1;
			my $pbsr=$2;

			my $id = &compare(\@c1, $pbsr);
			$seqid{"c$i"}=$id;
			$all{"c$i"}=$line;
			push(@ids, $id);

		    }
		}
		#print "@ids\n";

		my @ids1="";
		my @tms=`cat $tmoutput/Bsites_single.dat`;
		#print "@tms\n";
		for(my $i=0; $i<@tms; $i++)
		{
		    if($i>=5)
		    {
			last;
		    }
		    my $line=$tms[$i];
		    if($line =~ /\d+\t(\S+)\t\S+\t\S+\t(\S+)/)
		    {
			my $pbsr=$2;
			my $id = &compare(\@c1, $pbsr);
			push(@ids1, $id);
			$seqid{"t$i"}=$id;
			$all{"t$i"}=$line;
		    }
		}
		#print "@ids1\n";

		my @keys=sort{$seqid{$b}<=>$seqid{$a}} keys %seqid;

		my $top=0;
		foreach my $k(@keys)
		{
		    if($top>=5)
		    {
			last;
		    }	

		    if($seqid{$k}>0.5 || $top <1)
		    {
			printf OUT "$k\t%.2f\t$all{$k}", $seqid{$k};
			$top++;
		    }		    
		}		
	    }
	}
    }  
    close(OUT);
    `cp coach_cluster.dat $outputdir`;
}

sub compare
{
    my ($a_ref, $b_ref)=@_;
    my @a=@$a_ref;
    my @b=split(/,/, $b_ref);
    my %a1=();
    foreach my $r(@a) 
    {
	$a1{$r}=1;
    }
    
    my $n=0;
    foreach my $r(@b)
    {
	if(exists $a1{$r})
	{
	    $n++;
	}
    }    

    my $id=$n/@a;
    my $id1=$n/@b;
    if($id>$id1)
    {
	$id=$id1;
    }
    return $id;
}

sub dist
{
    my ($x1, $y1, $z1, $x2, $y2, $z2)=@_;
    my $dist =sqrt(($x1 - $x2)**2 + ($y1 - $y2)**2 + ($z1 - $z2)**2);

    return($dist);
}


sub COFpred
{
    my ($name, $len, $top_cut, $cscore_ref)=@_;
    my %prob=();
    my $nucflag=0;

    open(FIN1, "<$cofoutput/Bsites_prob.dat");
    open(FINp, "<$cofoutput/Bsites.dat");
    my $topN=0;
    my $cscore=0;
    my $lig="";
    my $BS=0;
    while(my $line = <FIN1>)
    {	
	chomp($line);
	my $linep = <FINp>;
	if($line !~ /\S+/)	    		
	{	   
	    print "sth wrong for COFACTOR $line\n";
	    next;
	}
	if($linep =~ /\d+\s+(\S+)\s+\S+\s+\S+\s+\S+\s+\S+\s+\S+\s+(\S+)\s+\S+\s+(\S+).+:\S+/)
	{
	    $cscore=$1;
	    $lig=$2;
	    $BS=$3;
	    #print "$1, $2, $3\n";

	    if($BS>=1.95)
	    {		
		$cscore=$BS; #increase cscore manually due to high local similarity
		#print "update cscore to $BS\n";		
	    }

	    if($cscore<0)
	    {
		$cscore=0.01;
	    }
	}

	if($lig eq "NUC" && $topN == 0)
	{
	    $nucflag=1;
	}


	$topN++;
	if($topN<=$top_cut)
	{
	    my @pred1=split(' ', $line);
	    my $nn=@pred1;
	    if($nn!=$len)
	    {
		print "wrong length $nn != $len!\n";
	    }
	    
	    for(my $i=1; $i<=$len; $i++)
	    {		
		push(@{$prob{$i}}, $cscore*$pred1[$i-1]);		    		    
	    }

	    $$cscore_ref{$topN}=$cscore;
	}   	
	else
	{
	    last;
	}
    }
    close(FIN1);
    close(FINp);

    return ($nucflag, \%prob);
}


sub COFpred_cat
{
    ###NUC will be excluded
    my ($name, $len, $top_cut, $cscore_ref)=@_;
    my %prob=();

    open(FIN1, "<$cofoutput/Bsites_prob.dat");
    open(FINp, "<$cofoutput/Bsites.dat");
    my $topN=0;
    my $cscore=0;
    my $lig="";
    my $BS=0;
    while(my $line = <FIN1>)
    {	
	chomp($line);
	my $linep = <FINp>;
	if($line !~ /\S+/)	    		
	{	   
	    print "sth wrong for COFACTOR $line\n";
	    next;
	}


	if($linep =~ /\d+\s+(\S+)\s+\S+\s+\S+\s+\S+\s+\S+\s+\S+\s+(\S+)\s+\S+\s+(\S+).+:\S+/)
	{
	    $cscore=$1;
	    $lig=$2;	 
	    $BS=$3;
	    
	    next if($lig eq "NUC");
	    
	    #print "$1, $2, $3\n";

	    if($BS>=1.95)
	    {		
		$cscore=$BS; #increase cscore manually due to high local similarity
		#print "update cscore to $BS\n";		
	    }

	    if($cscore<0)
	    {
		$cscore=0.01;
	    }
	}
	
	$topN++;
	if($topN<=$top_cut)
	{
	    my @pred1=split(' ', $line);
	    my $nn=@pred1;
	    if($nn!=$len)
	    {
		print "wrong length $nn != $len!\n";
	    }
	    
	    for(my $i=1; $i<=$len; $i++)
	    {		
		push(@{$prob{$i}}, $cscore*$pred1[$i-1]);		    		    
	    }

	    $$cscore_ref{$topN}=$cscore;
	}   	
	else
	{
	    last;
	}
    }
    close(FIN1);
    close(FINp);

    return \%prob;
}

sub TMpred
{
    my ($name, $len, $top_cut, $cscore_ref)=@_;
    my %prob=();
    my $nucflag=0;
    my $name1=$modelname;
    if(-s "$tmoutput/Bsites_prob.dat")
    {     
	open(FIN1, "<$tmoutput/Bsites_prob.dat");
	open(FINp, "<$tmoutput/Bsites.dat");
	open(FINt, "<$tmoutput/Bsites_single.dat");
	my $topN=0;

	my $cscore=0;
	while(my $line = <FIN1>)
	{	
	    chomp($line);
	    my $linep = <FINp>;
	    my $linet = <FINt>;
	    if($line !~ /\S+/)
	    {	   
		print "sth wrong for TMSITE\n";
		next;
	    }	    

	    if($linep =~/^(\S+)\t/)
	    {
		$cscore=$1;
	    }
	    if($linet =~ /\t/)
	    {
		my @a=split(/\t/, $linet);
		if($a[3] =~ /NUC$/ && $topN==0)
		{
		    $nucflag=1;
		}
	    }  


	    
	    $topN++;
	    if($topN<=$top_cut)
	    {
		my @pred1=split(' ', $line);
		my $nn=@pred1;
		if($nn!=$len)
		{
		    print "wrong length $nn != $len!\n";
		}
		
		for(my $i=1; $i<=$len; $i++)
		{		
		    push(@{$prob{$i}}, $cscore*$pred1[$i-1]);		    		    
		}
		$$cscore_ref{$topN}=$cscore;	 
	    }   	
	    else
	    {
		last;
	    }
	}
	close(FIN1);
	close(FINp);
    }

    return ($nucflag, \%prob);
}

sub TMpred_cat
{
    my ($name, $len, $top_cut, $cscore_ref)=@_;
    my %prob=();
    my $name1=$modelname;
    if(-s "$tmoutput/Bsites_prob.dat")
    {     
	open(FIN1, "<$tmoutput/Bsites_prob.dat");
	open(FINp, "<$tmoutput/Bsites.dat");
	open(FINt, "<$tmoutput/Bsites_single.dat");
	my $topN=0;

	my $cscore=0;
	while(my $line = <FIN1>)
	{	
	    chomp($line);
	    my $linep = <FINp>;
	    my $linet = <FINt>;
	    if($line !~ /\S+/)
	    {	   
		print "sth wrong for TMSITE\n";
		next;
	    }

	    if($linet =~ /\t/)
	    {
		my @a=split(/\t/, $linet);
		if($a[3] =~ /NUC$/)
		{
		    next;
		}
	    }
	    

	    if($linep =~/^(\S+)\t/)
	    {
		$cscore=$1;
	    }
	    
	    $topN++;
	    if($topN<=$top_cut)
	    {
		my @pred1=split(' ', $line);
		my $nn=@pred1;
		if($nn!=$len)
		{
		    print "wrong length $nn != $len!\n";
		}
		
		for(my $i=1; $i<=$len; $i++)
		{		
		    push(@{$prob{$i}}, $cscore*$pred1[$i-1]);		    		    
		}
		$$cscore_ref{$topN}=$cscore;	 
	    }   	
	    else
	    {
		last;
	    }
	}
	close(FINt);
	close(FIN1);
	close(FINp);
    }

    return \%prob;
}


sub SSpred
{
    my ($name, $len, $top_cut, $cscore_ref)=@_;
    my %prob=();

    if(-s "$ssoutput/Bsites_prob_fpt.dat")
    {     
	open(FIN1, "<$ssoutput/Bsites_prob_fpt.dat");
	open(FINp, "<$ssoutput/Bsites_fpt.dat");
	my $topN=0;

	my $cscore=0;
	while(my $line = <FIN1>)
	{	
	    chomp($line);
	    my $linep = <FINp>;
	    if($line !~ /\S+/)
	    {	   
		print "sth wrong for SSITE\n";
		next;
	    }
	    if($linep =~/^(\S+)\t/)
	    {
		$cscore=$1;
	    }
	    
	    $topN++;
	    if($topN<=$top_cut)
	    {
		my @pred1=split(' ', $line);
		my $nn=@pred1;
		if($nn!=$len)
		{
		    print "wrong length $nn != $len!\n";
		}
		
		for(my $i=1; $i<=$len; $i++)
		{		
		    push(@{$prob{$i}}, $cscore*$pred1[$i-1]);		    		    
		}
		$$cscore_ref{$topN}=$cscore;
	    }   	
	    else
	    {
		last;
	    }
	}
	close(FIN1);
	close(FINp);
    }

    return \%prob;
}



sub FINpred
{
    my ($name, $len, $top_cut, $cscore_ref)=@_;
    my %prob=();

    my %pred=();
    for(my $i=1; $i<=$len; $i++)
    {
	$pred{$i}=0.0;
    }
    my $name1=$modelname;
    
    if(-s "$finoutput/$name1.pockets.dat")
    { 
	my $nt=0;
	open(FINp, "<$finoutput/$name1.pockets.pdb") or die "$finoutput/$name1.pockets.pdb is missed\n";
	while(my $line = <FINp>)
	{
	    if($line =~ /PKT M\s+(\d+)\s+/)	
	    {
		$nt += $1;
	    }
	}
	close(FINp);


	open(FIN1, "<$finoutput/$name1.pockets.dat");
	my $topN=0;
	my $tot_pred=0;
	my $cscore=0;
	while(my $line = <FIN1>)
	{
	    if($line =~ /^POCKET\s+(\d+)\s+(\d+)\s+(\S+)/)
	    {
		my $nt1=$2;
		$cscore=$3;
		
		if($nt1<5)
		{
		    $cscore=0.01;
		}
		$topN++;
		if($topN > $top_cut )
		{
		    last;
		}
		$$cscore_ref{$topN}=$cscore;
	    }
	    	    
	    if($line =~ /^TER/) 
	    {

		for(my $i=1; $i<=$len; $i++)
		{		
		    push(@{$prob{$i}}, $pred{$i});
		}

		for(my $i=1; $i<=$len; $i++)
		{
		    $pred{$i}=0.0;
		}
	    }

	    if($line =~ /^RESIDUE/)
	    {
		my $res_no = substr($line, 7, 6);  $res_no =~ s/\s+//;
		my $prob   = substr($line, 31, 8); $prob   =~ s/\s+//;   	   
		if($res_no > $len)
		{
		    die "$res_no > $len";
		}
		$pred{$res_no}  =  sprintf("%.3f", $cscore*$prob);
	    }
	}
	close(FIN1);
    }
    return \%prob;
}



sub CONpred
{
    my ($name)=@_;
    my %prob=();

    my $conpred="$modelname.bsr";

    if(-s "$conoutput/$conpred")
    {
	open(FIN, "$conoutput/$conpred");
	while(my $line=<FIN>)
	{   
	    chomp($line);
	    if($line=~/^(\d+)/)
	    {
		if($line=~/(\S+)\s+\S+\s+(\S+)/)
		{      
		    my $ix=$1;
		    my $score=$2;
		    $ix=sprintf("%d", $ix);
		    $score=sprintf("%.3f", $score);
		    $prob{$ix} = $score;
		}
	    }
	}
	close(FIN);
    }

    return \%prob;
}


sub z_scores
{
     my($score_ref, $z_score_ref)=@_;
     my %r_score  =%$score_ref;

     my @keys = keys %r_score;
     my $Lch = @keys;
     my $z1_a  = 0; my $z1_a2=0; my %zscore=();
     foreach my $i(@keys)
     {
         $z1_a  += $r_score{$i};
         $z1_a2 += $r_score{$i}**2;
     }
     $z1_a/=$Lch;
     $z1_a2/=$Lch;
     my $z1_sd = sqrt($z1_a2 - $z1_a**2);

     foreach my $i(@keys)
     {
         $$z_score_ref{$i}=($r_score{$i}-$z1_a)/$z1_sd;
     }
}


sub metal_cof0
{
    ##get metal prediction from COFACTOR
    #my %bions=('K'=>1,'MG'=>1,'ZN'=>1,'MN'=>1,'CO'=>1,'FE'=>1,'FE2'=>1,'NI'=>1,'MO'=>1,'CA'=>1,'NA'=>1,'CU1'=>1,'CU2'=>1,'CU'=>1,'AG'=>1, 'SO4'=>1, 'PO4'=>1, 'NH4'=>1, 'IOD'=>1, 'BR'=>1, 'PT'=>1, 'BA'=>1);
    my %bions=('K'=>1,'MG'=>1,'ZN'=>1,'MN'=>1,'CO'=>1,'FE'=>1,'FE2'=>1,'NI'=>1,'MO'=>1,'CA'=>1,'NA'=>1,'CU1'=>1,'CU2'=>1,'CU'=>1,'AG'=>1, 'NH4'=>1, 'BR'=>1, 'PT'=>1, 'BA'=>1, 'HG'=>1);


 
    open(FIN, "<$cofoutput/Bsites.dat");

    my $topN=0;
    my %prob=();
    while(my $line = <FIN>)
    {	
	chomp($line);
	if($line =~ /\d+\s+(\S+)\s+\S+\s+\S+\s+\S+\s+\S+\s+\S+\s+(\S+)\s+\S+\s+(\S+).+:(\S+)/)
	{
	    my $cscore=$1;
	    my $lig=$2;
	    my $BS=$3;
	    my $bsr=$4;
	    $topN++;
	    if($topN>20 && $cscore<0.3)
	    {
		last;
	    }
	    #print "$1, $2, $3\n";

	    if($BS>=1.8)
	    {		
		$cscore=1.0; #increase cscore manually due to high local similarity		
	    }

	    if($cscore<0)
	    {
		$cscore=0.01;
	    }
	

	    if(exists $bions{$lig})
	    {
		if($cscore>=0.2 && $BS>=1.1)
		{
		    if($cscore>=0.6)
		    {
			$cscore=1.0;
		    }
		    my @pred=split(',', $bsr);	    
		    foreach my $i(@pred)
		    {	
			if(!exists $prob{$i})
			{
			    $prob{$i}=$cscore;
			}
			else
			{
			    if($prob{$i}<$cscore)
			    {
				$prob{$i}=$cscore;
			    }
			}
		    }			    
		}
	    }   
	}
    }
    close(FIN);

    return %prob;
}


sub metal_cof
{
    ##get metal prediction from COFACTOR
    my %bions=('K'=>1,'MG'=>1,'ZN'=>1,'MN'=>1,'CO'=>1,'FE'=>1,'FE2'=>1,'NI'=>1,'MO'=>1,'CA'=>1,'NA'=>1,'CU1'=>1,'CU2'=>1,'CU'=>1,'AG'=>1, 'NH4'=>1, 'BR'=>1, 'PT'=>1, 'BA'=>1, 'HG'=>1, 'LA'=>1);


    my $mflag=0;

    my $topN=0;
    my %prob=();
    for(my $i=1; $i<=$len; $i++)
    {
	$prob{$i}=0.0;
    }
 
    if(!-s "$cofoutput/Bsites.dat")
    {
	return ($mflag, \%prob);
    }

    my $Nmetal=0;
    my $maxprob=0;
    open(FIN, "<$cofoutput/Bsites.dat");
    while(my $line = <FIN>)
    {	
	chomp($line);
	if($line =~ /\d+\s+(\S+)\s+\S+\s+\S+\s+\S+\s+\S+\s+\S+\s+(\S+)\s+\S+\s+(\S+).+:(\S+)/)
	{
	    my $cscore=$1;
	    my $lig=$2;
	    my $BS=$3;
	    my $bsr=$4;
	    $topN++;
	    if($topN>20 && $cscore<0.3)
	    {
		last;
	    }

	    if($Nmetal>=2)
	    {
		last;
	    }


	    #print "$1, $2, $3\n";

	    if($BS>=1.8)
	    {		
		$cscore=1.0; #increase cscore manually due to high local similarity		
	    }

	    if($cscore<0)
	    {
		$cscore=0.01;
	    }
	

	    if(exists $bions{$lig})
	    {
		if($cscore>=0.2 && $BS>=1.1)
		{
		    if($cscore>=0.6)
		    {
			$cscore=1.0;
		    }

		    my %prob1 = &ProtLigContact($len, "$cofoutput/complex$topN.pdb");
		    $mflag=1;
		    $Nmetal++;

		    for(my $i=1; $i<=$len; $i++)
		    {
			my $p = $cscore*$prob1{$i};
			$prob{$i} = $p if($prob{$i}<$p);
			
			$maxprob=$prob{$i} if($maxprob<$prob{$i});
		    }			    
		}
	    }   
	}
    }
    close(FIN);


    my $cameocut=0.51;
    if($maxprob<=$cameocut) ##CAMEO will not accept such prediction
    {
	my $cut=int(0.05 * $len);
	$cut=1 if($cut<1);
	$cut=5 if($cut>5);
	
	my $inc=0.36;
	if(($cameocut-$maxprob)>$inc)
	{
	    $inc=$cameocut-$maxprob;
	}
	
	##upgrade the top prob
	my @keys=sort {$prob{$b} <=> $prob{$a}} keys %prob;
	$prob{$keys[0]} += $inc;
	$prob{$keys[0]} = 1 if($prob{$keys[0]}>1);
	for(my $i=1; $i<$cut; $i++)
	{
	    if($prob{$keys[$i]}>=0.15)
	    {
		$prob{$keys[$i]} += $inc;
		$prob{$keys[$i]} = 1 if($prob{$keys[$i]}>1);
	    }
	}	
    }


    return ($mflag, \%prob);
}


sub ProtLigContact
{
    my ($len, $complex)=@_;

    my %prob = ();
    for(my $i=1; $i<=$len; $i++)
    {
	$prob{$i}=0.0;
    }
    
    if(!-s $complex)
    {
	return %prob;
    }
    

    my @protein  = ();
    my @ligand   = ();
    open(COM, $complex);
    while(my $line = <COM>)
    {
	chomp($line);
	if($line =~ /^ATOM/)
	{
	    push(@protein, $line);
	}
	elsif($line =~ /^HETATM/)
	{
	    push(@ligand, $line);
	}	
    }
    close(COM);

    foreach my $line1(@protein)
    {
	chomp($line1);

	my $res_no = substr($line1, 22, 5); $res_no=~s/\s+//mg;
	my $atom1  = substr($line1, 12, 2); $atom1 =~s/[\d+|\s+]//mg;  ##atom name

	if($atom1  =~/H/g) #ignore hydrogen
	{
	    next;
	}
	my $x1=substr($line1, 30, 8);
	my $y1=substr($line1, 38, 8);
	my $z1=substr($line1, 46, 8);

	foreach my $line2(@ligand)
	{
	    my $atom2 = substr($line2, 12, 2); $atom2 =~s/[\d+|\s+]//mg;

	    if($atom2  =~/H/g) #ignore hydrogen
	    {
		#next;
	    }
	    my $x2 = substr($line2, 30, 8);
	    my $y2 = substr($line2, 38, 8);
	    my $z2 = substr($line2, 46, 8);
	    
	    my $distance    = dist($x1, $y1, $z1, $x2, $y2, $z2);

	    my $p = 1.0/(1+exp(1.5*$distance - 7.5));
	    if($p>$prob{$res_no})
	    {
		$prob{$res_no} = $p;
	    }
	}
    }   

    return %prob;
}
